/* original parser id follows */
/* yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93" */
/* (use YYMAJOR/YYMINOR for ifdefs dependent on parser version) */

#define YYBYACC 1
#define YYMAJOR 2
#define YYMINOR 0
#define YYPATCH 20230219

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)
#define YYENOMEM       (-2)
#define YYEOF          0
#undef YYBTYACC
#define YYBTYACC 0
#define YYDEBUGSTR YYPREFIX "debug"
#define YYPREFIX "yy"

#define YYPURE 0

#line 92 "xkbparse.y"
#ifdef DEBUG
#define	YYDEBUG 1
#endif
#define	DEBUG_VAR parseDebug
#include "parseutils.h"
#include <X11/keysym.h>
#include <X11/extensions/XKBgeom.h>
#include <stdlib.h>

unsigned int parseDebug;

#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#line 110 "xkbparse.y"
typedef union YYSTYPE	{
	int		 ival;
	unsigned	 uval;
	char		*str;
	Atom	 	sval;
	ParseCommon	*any;
	ExprDef		*expr;
	VarDef		*var;
	VModDef		*vmod;
	InterpDef	*interp;
	KeyTypeDef	*keyType;
	SymbolsDef	*syms;
	ModMapDef	*modMask;
	GroupCompatDef	*groupCompat;
	IndicatorMapDef	*ledMap;
	IndicatorNameDef *ledName;
	KeycodeDef	*keyName;
	KeyAliasDef	*keyAlias;
	ShapeDef	*shape;
	SectionDef	*section;
	RowDef		*row;
	KeyDef		*key;
	OverlayDef	*overlay;
	OverlayKeyDef	*olKey;
	OutlineDef	*outline;
	DoodadDef	*doodad;
	XkbFile		*file;
} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */
#line 72 "xkbparse.c"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

#if !(defined(yylex) || defined(YYSTATE))
int YYLEX_DECL();
#endif

/* Parameters sent to yyerror. */
#ifndef YYERROR_DECL
#define YYERROR_DECL() yyerror(const char *s)
#endif
#ifndef YYERROR_CALL
#define YYERROR_CALL(msg) yyerror(msg)
#endif

extern int YYPARSE_DECL();

#define END_OF_FILE 0
#define ERROR_TOK 255
#define XKB_KEYMAP 1
#define XKB_KEYCODES 2
#define XKB_TYPES 3
#define XKB_SYMBOLS 4
#define XKB_COMPATMAP 5
#define XKB_GEOMETRY 6
#define XKB_SEMANTICS 7
#define XKB_LAYOUT 8
#define INCLUDE 10
#define OVERRIDE 11
#define AUGMENT 12
#define REPLACE 13
#define ALTERNATE 14
#define VIRTUAL_MODS 20
#define TYPE 21
#define INTERPRET 22
#define ACTION_TOK 23
#define KEY 24
#define ALIAS 25
#define GROUP 26
#define MODIFIER_MAP 27
#define INDICATOR 28
#define SHAPE 29
#define KEYS 30
#define ROW 31
#define SECTION 32
#define OVERLAY 33
#define TEXT 34
#define OUTLINE 35
#define SOLID 36
#define LOGO 37
#define VIRTUAL 38
#define EQUALS 40
#define PLUS 41
#define MINUS 42
#define DIVIDE 43
#define TIMES 44
#define OBRACE 45
#define CBRACE 46
#define OPAREN 47
#define CPAREN 48
#define OBRACKET 49
#define CBRACKET 50
#define DOT 51
#define COMMA 52
#define SEMI 53
#define EXCLAM 54
#define INVERT 55
#define STRING 60
#define INTEGER 61
#define FLOAT 62
#define IDENT 63
#define KEYNAME 64
#define PARTIAL 70
#define DEFAULT 71
#define HIDDEN 72
#define ALPHANUMERIC_KEYS 73
#define MODIFIER_KEYS 74
#define KEYPAD_KEYS 75
#define FUNCTION_KEYS 76
#define ALTERNATE_GROUP 77
#define YYERRCODE 256
typedef int YYINT;
static const YYINT yylhs[] = {                           -1,
    0,    0,    0,   72,   72,   71,    5,    5,    5,   68,
   68,   69,   70,    6,    6,    6,    6,    6,   12,   12,
   11,   11,   10,   10,   10,   10,   10,   10,   10,   10,
   21,   21,   22,   22,   22,   22,   22,   22,   22,   22,
   22,   22,   22,   22,   22,   22,   22,   37,   37,   37,
   52,   53,   41,   42,   42,   43,   43,   44,   45,   45,
   38,   38,   46,   47,   39,   39,   39,   40,   40,   40,
   40,   40,   29,   29,   49,   48,   50,   51,   51,   54,
   54,   55,   56,   56,   57,   57,   57,   57,   57,   58,
   58,   59,   59,   60,   60,   61,   61,   62,   63,   63,
   64,   65,   65,   66,   66,   66,   36,   36,   35,   67,
    9,    9,    9,    9,   17,   17,   19,   19,   19,   19,
   19,   19,   19,   19,   19,   19,   19,    8,    8,    7,
    7,    7,    7,    7,   23,   23,   24,   24,   25,   25,
   25,   25,   25,   25,   26,   26,   26,   26,   26,   26,
   26,   26,   34,   34,   33,   27,   27,   27,   27,   28,
   28,   28,   28,   31,   31,   32,   32,   32,   32,   16,
   16,   16,   30,    4,    4,    1,    1,    3,    2,   13,
   18,   18,   20,   15,   15,   14,
};
static const YYINT yylen[] = {                            2,
    1,    1,    1,    2,    1,    7,    1,    1,    1,    2,
    1,    7,    4,    1,    1,    1,    1,    1,    1,    0,
    2,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    2,    0,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    4,    2,    3,
    4,    5,    3,    3,    1,    1,    3,    6,    3,    1,
    2,    1,    6,    6,    3,    1,    0,    3,    3,    1,
    2,    1,    3,    3,    5,    6,    6,    5,    6,    6,
    6,    6,    2,    1,    5,    1,    1,    1,    1,    2,
    1,    5,    1,    3,    1,    1,    3,    6,    3,    1,
    3,    3,    1,    3,    5,    3,    3,    1,    5,    6,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    0,    1,
    1,    1,    1,    1,    1,    0,    3,    1,    3,    3,
    3,    3,    3,    1,    2,    2,    2,    2,    1,    4,
    1,    3,    3,    1,    4,    1,    3,    4,    6,    1,
    1,    1,    1,    1,    0,    3,    3,    1,    1,    1,
    1,    1,    3,    2,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    0,    1,
};
static const YYINT yydefred[] = {                         0,
   23,   24,   25,   26,   27,   28,   29,   30,    0,   22,
    0,    0,    0,   11,    3,    5,    0,   21,    7,   14,
   15,   17,   16,   18,    8,    9,    0,    0,    0,   10,
    0,    4,  186,  184,    0,    0,    0,    0,   32,    0,
    0,    0,    0,  130,  132,  131,  133,  134,    0,    0,
   31,    0,    0,   47,    0,    0,    0,  117,    0,    0,
    0,    0,    0,    0,  125,    0,    0,  112,  113,  114,
    0,    0,  181,  180,  182,    0,    0,    0,    0,  116,
    0,   33,   34,   35,   38,   39,   40,   41,   42,   43,
   36,   37,   44,   45,   46,    6,   12,    0,    0,   55,
  183,    0,  171,  179,  170,  172,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   49,    0,    0,    0,   53,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   50,
    0,  119,  118,  120,  121,  122,  123,  124,  126,  127,
    0,    0,    0,    0,    0,  178,  161,  162,  163,    0,
  115,  160,    0,  144,    0,  151,    0,    0,    0,    0,
   54,   62,    0,    0,    0,    0,    0,    0,    0,   72,
    0,   66,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  108,    0,    0,  103,    0,    0,    0,   86,   88,
    0,   84,   89,   87,    0,    0,  146,  149,  145,    0,
  147,  148,    0,    0,    0,    0,    0,   51,    0,  158,
    0,   48,    0,   61,    0,    0,    0,    0,  168,    0,
  169,    0,    0,  154,    0,   71,    0,    0,    0,   52,
   75,    0,    0,   78,    0,    0,    0,  177,  176,  175,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   83,
    0,    0,  152,    0,    0,    0,    0,  139,  142,    0,
    0,   63,   58,    0,    0,   73,    0,   74,    0,    0,
   69,   64,   65,   76,    0,   77,  104,  174,    0,    0,
    0,   81,  107,   80,  102,    0,   93,    0,   91,    0,
   82,   79,  110,  150,  159,  173,    0,  166,  167,  153,
    0,    0,    0,    0,   90,    0,    0,  100,  155,  109,
  105,    0,   96,    0,   95,   85,    0,    0,    0,    0,
    0,    0,  101,   98,   99,   97,   92,   94,
};
#if defined(YYDESTRUCT_CALL) || defined(YYSTYPE_TOSTRING)
static const YYINT yystos[] = {                           0,
   70,   71,   72,   73,   74,   75,   76,   77,  258,  268,
  269,  270,  326,  327,  328,  329,  330,  268,    1,    2,
    3,    4,    5,    6,    7,    8,  263,  264,  270,  327,
  270,  329,   60,  272,  273,  273,  264,   45,   45,  279,
  273,  326,  279,   10,   11,   12,   13,   14,  265,  266,
  280,   46,   46,   60,   20,   21,   22,   23,   24,   25,
   26,   27,   28,   29,   31,   32,   34,   35,   36,   37,
   38,   54,   63,   64,   71,  267,  271,  275,  276,  277,
  285,  295,  299,  302,  304,  305,  306,  307,  308,  309,
  310,  311,  312,  313,  325,   53,   53,  276,  300,  301,
   60,  278,   32,   61,   63,  260,  274,  303,  271,  271,
  260,  276,  260,  278,  278,  278,   28,  276,  278,   40,
   49,   51,   53,   40,   40,   52,   53,   45,   41,   45,
   45,   40,   40,   45,   40,   45,   45,   45,  260,   53,
   45,   21,   22,   24,   26,   27,   28,   29,   32,   34,
   41,   42,   47,   54,   55,   62,  260,  261,  271,  275,
  276,  278,  283,  284,  285,  286,  283,  275,  283,  283,
  301,  295,  296,  283,  296,   49,   54,  276,  285,  287,
  297,  298,  271,  283,  282,  283,  283,  296,   45,   49,
  276,  293,  294,  323,  324,   28,   31,   33,  295,  308,
  314,  315,  320,  325,   40,  296,  284,  285,  284,  283,
  284,  284,   47,   41,   42,   43,   44,   53,   40,   50,
   49,   53,   46,  295,   46,   32,   45,   63,  274,  275,
  288,  289,  290,  291,  292,  276,   40,   46,   52,   53,
   53,   46,   52,   53,   46,  294,   42,   61,   62,  259,
  262,   40,   46,   52,   46,   52,   45,  278,   46,  315,
  283,   46,   48,  281,  282,  283,  283,  283,  283,  283,
  283,   53,   53,  290,   47,   50,   52,   50,   52,  283,
  287,   53,  298,   53,  283,   53,   46,  259,   52,   45,
  283,   53,  293,   53,  324,   30,  295,  316,  317,   45,
   53,   53,   53,   48,   50,   46,  281,  274,  288,  291,
  262,  294,   45,   46,  317,  271,  321,  322,   48,   50,
   46,   45,  271,  318,  319,   53,   40,   46,   52,  282,
   46,   52,  271,   53,  322,   46,   53,  319,
};
#endif /* YYDESTRUCT_CALL || YYSTYPE_TOSTRING */
static const YYINT yydgoto[] = {                          9,
  250,  157,  158,  251,   27,   28,   49,   50,   76,   10,
   11,   29,  159,   34,   35,  229,  160,  161,   80,  162,
   40,   51,  264,  265,  186,  164,  165,  166,  180,  231,
  232,  233,  234,  235,  192,  193,  172,  173,  181,  182,
   83,   99,  100,   84,  108,   85,   86,   87,   88,  200,
   90,   91,   92,   93,   94,  201,  202,  298,  299,  324,
  325,  203,  317,  318,  194,  195,  204,   13,   14,   15,
   16,   17,
};
static const YYINT yysindex[] = {                       525,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  525,  778,  525,    0,    0,    0,  525,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  -46,  -46,  679,    0,
  241,    0,    0,    0,    3,   17,  -46,  525,    0,  703,
   17,  114,    8,    0,    0,    0,    0,    0,   36,  467,
    0,   86,   93,    0,   39,   97,   24,    0,  100,  100,
  132,   39,   40,   97,    0,   97,    0,    0,    0,    0,
  169,   39,    0,    0,    0,   97,  175,   -2,  174,    0,
  176,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  195,   79,    0,
    0,  186,    0,    0,    0,    0,  204,  207,  230,  244,
  247,  259,  272,  299,  301,  309,  132,  261,  310,  678,
  678,   44,    0,  678,  678,   39,    0,  951,  678,  951,
  742,  100,  678,  678,  678,  951,   43,  724,  277,    0,
  951,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  678,  678,  678,  678,  678,    0,    0,    0,    0,  583,
    0,    0,  158,    0,  329,    0,  287,  323,  213,  595,
    0,    0,  780,  595,  796,  834,   39,    0,  351,    0,
   81,    0,  343,  265,  101,  595,  292,  854,  362,  -11,
  372,    0,  129,  152,    0,   97,  368,   97,    0,    0,
    6,    0,    0,    0,  678,  892,    0,    0,    0,  581,
    0,    0,  678,  678,  678,  678,  678,    0,  678,    0,
  678,    0,  374,    0,  381,    0,   48,    0,    0,  389,
    0,  406,  402,    0,  210,    0,  586,  423,  742,    0,
    0,  444,  678,    0,  454,  201,   -3,    0,    0,    0,
  407,  632,  458,  362,  463,   41,  913,  419,  470,    0,
  356,  479,    0,  438,  497,  107,  107,    0,    0,  595,
  485,    0,    0,  215,  678,    0,   48,    0,   44,  595,
    0,    0,    0,    0,  595,    0,    0,    0,  -11,  362,
  595,    0,    0,    0,    0,  514,    0,  269,    0,  100,
    0,    0,    0,    0,    0,    0,  522,    0,    0,    0,
  529,  242,   80,  528,    0,  548,  349,    0,    0,    0,
    0,  678,    0,  433,    0,    0,  100,  552,  100,  460,
  553,   80,    0,    0,    0,    0,    0,    0,
};
static const YYINT yyrindex[] = {                       985,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  993,    0,  665,    0,    0,    0,  116,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  571,  339,    0,    0,
    0,    0,    0,    0,    0,  394,  571,  725,    0,  446,
    0,  725,  519,    0,    0,    0,    0,    0,  540,    0,
    0,    0,    0,    0,    0,  112,  156,    0,  163,    0,
  262,  276,  307,  384,    0,  404,    4,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  579,  411,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  126,    0,    0,
    0,    0,    0,    0,    0,    0,  576,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  462,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  228,
    0,    0,    0,    0,  337,    0,    0,  397,    0,  167,
    0,    0,    0,  597,    0,  543,    0,  473,    0,    0,
    0,    0,    0,    0,    0,  237,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  307,  412,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  578,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  291,    0,  468,    0,    0,
    0,    0,  593,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  596,  124,  191,    0,    0,  539,
    0,    0,    0,    0,  578,    0,    0,    0,    0,  506,
    0,    0,    0,    0,  340,    0,    0,    0,    0,    0,
  534,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
};
#if YYBTYACC
static const YYINT yycindex[] = {                         0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
};
#endif
static const YYINT yygindex[] = {                         0,
  398,  -56,    0,  342,    0,  622,    0,    0,    0,  641,
    0,   46,  -50,    0,  -24,  -55,    7,  -47,    0,  -40,
  623,    0,  400, -128,  105,  382,  -33,    0,  435,  399,
    0,  451,  401,    0,  434, -177,  -39,   87,    0,  450,
    0,    0,  564,    0,    0,    0,    0,    0,    0,  647,
    0,    0,    0,    0,    0,    0,  490,    0,  410,    0,
  366,    0,    0,  392,    0,  455,  668,  684,   32,    0,
  706,    0,
};
#define YYTABLESIZE 1022
static const YYINT yytable[] = {                         77,
  106,  107,   79,   36,  111,  185,  113,   98,  109,  110,
   82,  246,   41,   33,  112,  102,   81,   44,   45,   46,
   47,   48,  114,  115,  118,  116,  142,  143,   58,  144,
  247,  145,  146,  196,  148,  119,  197,  149,  198,   67,
   68,   69,   70,  127,   30,   12,  121,   38,  122,  248,
  249,  259,  127,   53,  127,  103,   78,  248,  249,   72,
  139,   39,   31,  111,  142,  143,   58,  144,   73,  145,
  146,  147,  148,   30,   65,  149,   75,  150,   98,  103,
   79,  183,   79,  178,  104,  189,  105,  189,   79,  191,
   79,  190,  227,   79,   81,   54,   81,  179,  199,  101,
  104,   73,   81,   73,   81,   73,   73,   81,  104,   75,
  105,   75,  312,   75,   75,    1,   20,  208,  208,  106,
  208,  208,   20,   20,  322,   79,  238,   79,  168,  236,
  126,  127,  239,  224,   78,  224,   78,   78,   96,   81,
   79,   81,   78,   74,   78,   97,  242,   78,  224,  216,
  217,  119,  243,   79,   81,  114,  101,  258,   79,   52,
  119,  199,  119,   74,  140,  140,  224,   81,  140,  140,
  106,  140,   81,  140,  253,  140,  140,   56,   56,   78,
  254,   78,  230,    1,    2,    3,    4,    5,    6,    7,
    8,  178,  104,  330,   78,  118,  117,  255,  214,  215,
  216,  217,  120,  256,  118,  179,  118,   78,  191,   79,
  218,  120,   78,  120,  120,  124,  175,  297,   57,   57,
  106,  308,  188,   81,  163,  167,  123,  206,  169,  170,
  128,  141,  141,  174,  125,  141,  141,  184,  141,  187,
  141,   19,  141,  141,  129,   78,  287,   25,   26,  316,
   79,  130,  254,  214,  215,  216,  217,  210,  297,  278,
  306,  279,  323,   78,   81,  222,  277,  156,  156,  156,
  156,  156,  156,  156,  131,  156,  333,  156,  316,  156,
  156,  323,  138,  132,  138,  230,  133,  321,  138,  142,
  143,   58,  144,  254,  145,  146,  147,  148,  296,   65,
  149,  121,  150,  134,   78,  214,  215,  216,  217,  261,
  121,  135,  121,  140,  314,  122,  205,  241,  266,  267,
  268,  269,   72,  270,  122,  271,  122,  214,  215,  216,
  217,   73,  214,  215,  216,  217,  220,  126,  185,   75,
  171,  280,  171,  136,  244,  137,  123,  285,  185,  185,
  185,  185,  185,  138,  141,  123,  291,  123,  185,  185,
  185,  185,  185,  185,  185,  185,  185,  185,  219,  185,
  185,  221,  185,  185,  185,  185,  185,  149,  149,  149,
  149,  149,  149,  185,  149,  137,  149,  137,  149,  149,
  237,  137,  185,   32,  328,  240,  214,  215,  216,  217,
  329,  185,  185,   32,   32,   32,   32,   32,  302,  185,
  190,  252,  257,   32,   32,   32,   32,   32,   32,   32,
   32,   32,   32,  124,   32,   32,  272,   32,   32,   32,
   32,   32,  124,  273,  124,  275,  157,  157,  157,  157,
  157,  157,  157,  126,  157,   13,  157,   32,  157,  157,
  115,  125,  126,  277,  126,  276,   32,   32,  289,  115,
  125,  115,  125,  300,   32,  129,  129,  129,  129,  129,
  129,  129,  129,  129,  129,  282,  129,  129,  331,  129,
  129,  129,  129,  129,  332,  304,   55,   56,   57,   58,
   59,   60,   61,   62,   63,   64,  284,   65,   66,  129,
   67,   68,   69,   70,   71,  336,  286,   67,  129,  129,
  292,  243,  115,   67,  181,  294,  129,  170,   70,  170,
   72,  115,  301,  115,   70,  214,  215,  216,  217,   73,
   74,  303,  207,  209,  305,  211,  212,   75,  129,  129,
  129,  129,  129,  129,  129,  129,  129,  129,  243,  129,
  129,   68,  129,  129,  129,  129,  129,   68,  313,  128,
  128,  128,  128,  128,  128,  128,  128,  128,  128,  319,
  128,  128,  129,  128,  128,  128,  128,  128,  320,  106,
  326,  129,  129,  143,  143,  106,  143,  327,  143,  129,
  143,  143,  165,  128,    1,    2,    3,    4,    5,    6,
    7,    8,  128,  128,  334,  337,  142,  143,   58,  144,
  128,  145,  146,  147,  148,  185,   65,  149,  156,  150,
   60,  214,  215,  216,  217,  136,  151,  152,  263,  213,
  311,  121,  153,  122,  176,  214,  215,  216,  217,  154,
  155,   59,  164,  135,  288,  101,  104,  156,   73,   74,
   37,   18,  142,  143,   58,  144,   75,  145,  146,  147,
  148,   43,   65,  149,    2,  150,   20,   20,   20,   20,
   20,  281,  151,  152,  307,  309,  290,  274,  153,  310,
   20,   21,   22,   23,   24,  154,  155,  293,  283,  171,
  260,  101,  104,  156,   73,   74,   89,  338,  142,  143,
   58,  144,   75,  145,  146,  147,  148,  315,   65,  149,
  295,  150,   44,   45,   46,   47,   48,   95,  151,  152,
  335,   42,   32,    0,  153,    0,   20,   20,   20,   20,
   20,  154,  155,    0,    0,    0,    0,  101,  104,  156,
   73,   74,    0,    0,  142,  143,   58,  144,   75,  145,
  146,  196,  148,    0,  197,  149,  198,   67,   68,   69,
   70,    0,  142,  143,   58,  144,    0,  145,  146,  147,
  148,    0,   65,  149,    0,  150,    0,   72,   19,   20,
   21,   22,   23,   24,   25,   26,   73,    0,    0,    0,
  176,    0,    0,    0,   75,  177,    0,    0,    0,    0,
  142,  143,   58,  144,   73,  145,  146,  147,  148,    0,
   65,  149,   75,  150,    0,    0,  142,  143,   58,  144,
    0,  145,  146,  147,  148,  223,   65,  149,    0,  150,
    0,    0,    0,   72,    0,    0,    0,    0,    0,    0,
    0,  225,   73,    0,    0,    0,    0,    0,    0,   72,
   75,    0,    0,    0,  142,  143,   58,  144,   73,  145,
  146,  147,  148,    0,   65,  226,   75,  150,    0,    0,
    0,    0,    0,    0,  142,  143,   58,  144,  227,  145,
  146,  147,  148,    0,   65,  149,    0,  150,    0,    0,
    0,    0,    0,    0,  104,    0,  228,    0,    0,  245,
    0,    0,    0,    0,   75,    0,    0,   72,    0,    0,
    0,    0,  142,  143,   58,  144,   73,  145,  146,  147,
  148,    0,   65,  149,   75,  150,    0,    0,    0,    0,
    0,    0,    0,  142,  143,   58,  144,  262,  145,  146,
  147,  148,  296,   65,  149,   72,  150,    0,    0,    0,
    0,    0,    0,    0,   73,    0,    0,    0,    0,    0,
    0,    0,   75,    0,    0,    0,   72,    0,    0,    0,
    0,  142,  143,   58,  144,   73,  145,  146,  147,  148,
    0,   65,  149,   75,  150,   20,   20,   20,   20,   20,
   20,   20,   20,   19,   19,   19,   19,   19,   19,   19,
   19,    0,    0,    0,   72,    0,    0,    0,    0,    0,
    0,    0,    0,   73,    0,    0,    0,    0,    0,    0,
    0,   75,
};
static const YYINT yycheck[] = {                         50,
   57,   57,   50,   28,   61,  134,   63,   55,   59,   60,
   50,  189,   37,   60,   62,   56,   50,   10,   11,   12,
   13,   14,   63,   64,   72,   66,   21,   22,   23,   24,
   42,   26,   27,   28,   29,   76,   31,   32,   33,   34,
   35,   36,   37,   40,   13,    0,   49,   45,   51,   61,
   62,   46,   49,   46,   51,   32,   50,   61,   62,   54,
  117,   45,   17,   60,   21,   22,   23,   24,   63,   26,
   27,   28,   29,   42,   31,   32,   71,   34,  126,   32,
  128,  132,  130,  131,   61,   45,   63,   45,  136,  137,
  138,   49,   45,  141,  128,   60,  130,  131,  138,   60,
   61,   63,  136,   63,  138,   63,   63,  141,   61,   71,
   63,   71,  290,   71,   71,    0,    1,  151,  152,  176,
  154,  155,    7,    8,   45,  173,   46,  175,  122,  177,
   52,   53,   52,  173,  128,  175,  130,  131,   53,  173,
  188,  175,  136,   64,  138,   53,   46,  141,  188,   43,
   44,   40,   52,  201,  188,  196,   60,  198,  206,   46,
   49,  201,   51,   64,   41,   42,  206,  201,   45,   46,
  227,   48,  206,   50,   46,   52,   53,   52,   53,  173,
   52,  175,  176,   70,   71,   72,   73,   74,   75,   76,
   77,  239,   61,  322,  188,   40,   28,   46,   41,   42,
   43,   44,   40,   52,   49,  239,   51,  201,  256,  257,
   53,   49,  206,   51,   40,   40,  130,  257,   52,   53,
  277,  277,  136,  257,  120,  121,   53,  141,  124,  125,
   45,   41,   42,  129,   40,   45,   46,  133,   48,  135,
   50,    1,   52,   53,   41,  239,   46,    7,    8,  300,
  298,   45,   52,   41,   42,   43,   44,  153,  298,   50,
   46,   52,  313,  257,  298,   53,   52,   40,   41,   42,
   43,   44,   45,   46,   45,   48,  327,   50,  329,   52,
   53,  332,   46,   40,   48,  279,   40,   46,   52,   21,
   22,   23,   24,   52,   26,   27,   28,   29,   30,   31,
   32,   40,   34,   45,  298,   41,   42,   43,   44,  205,
   49,   40,   51,   53,   46,   40,   40,   53,  214,  215,
  216,  217,   54,  219,   49,  221,   51,   41,   42,   43,
   44,   63,   41,   42,   43,   44,   50,   47,    0,   71,
   50,  237,   52,   45,   53,   45,   40,  243,   10,   11,
   12,   13,   14,   45,   45,   49,  252,   51,   20,   21,
   22,   23,   24,   25,   26,   27,   28,   29,   40,   31,
   32,   49,   34,   35,   36,   37,   38,   41,   42,   43,
   44,   45,   46,   45,   48,   46,   50,   48,   52,   53,
   40,   52,   54,    0,   46,   53,   41,   42,   43,   44,
   52,   63,   64,   10,   11,   12,   13,   14,   53,   71,
   49,   40,   45,   20,   21,   22,   23,   24,   25,   26,
   27,   28,   29,   40,   31,   32,   53,   34,   35,   36,
   37,   38,   49,   53,   51,   47,   40,   41,   42,   43,
   44,   45,   46,   40,   48,    0,   50,   54,   52,   53,
   40,   40,   49,   52,   51,   50,   63,   64,   52,   49,
   49,   51,   51,   45,   71,   20,   21,   22,   23,   24,
   25,   26,   27,   28,   29,   53,   31,   32,   46,   34,
   35,   36,   37,   38,   52,   48,   20,   21,   22,   23,
   24,   25,   26,   27,   28,   29,   53,   31,   32,   54,
   34,   35,   36,   37,   38,   46,   53,   46,   63,   64,
   53,   52,   40,   52,   47,   53,   71,   50,   46,   52,
   54,   49,   53,   51,   52,   41,   42,   43,   44,   63,
   64,   53,  151,  152,   50,  154,  155,   71,   20,   21,
   22,   23,   24,   25,   26,   27,   28,   29,   52,   31,
   32,   46,   34,   35,   36,   37,   38,   52,   45,   20,
   21,   22,   23,   24,   25,   26,   27,   28,   29,   48,
   31,   32,   54,   34,   35,   36,   37,   38,   50,   46,
   53,   63,   64,   45,   46,   52,   48,   40,   50,   71,
   52,   53,   50,   54,   70,   71,   72,   73,   74,   75,
   76,   77,   63,   64,   53,   53,   21,   22,   23,   24,
   71,   26,   27,   28,   29,   45,   31,   32,   40,   34,
   45,   41,   42,   43,   44,   48,   41,   42,   48,   47,
  289,   49,   47,   51,   49,   41,   42,   43,   44,   54,
   55,   45,   50,   48,  247,   60,   61,   62,   63,   64,
   29,   11,   21,   22,   23,   24,   71,   26,   27,   28,
   29,   39,   31,   32,    0,   34,    2,    3,    4,    5,
    6,  237,   41,   42,  275,  277,   45,  227,   47,  279,
    2,    3,    4,    5,    6,   54,   55,  254,  239,  126,
  201,   60,   61,   62,   63,   64,   50,  332,   21,   22,
   23,   24,   71,   26,   27,   28,   29,  298,   31,   32,
  256,   34,   10,   11,   12,   13,   14,   50,   41,   42,
  329,   38,   17,   -1,   47,   -1,    2,    3,    4,    5,
    6,   54,   55,   -1,   -1,   -1,   -1,   60,   61,   62,
   63,   64,   -1,   -1,   21,   22,   23,   24,   71,   26,
   27,   28,   29,   -1,   31,   32,   33,   34,   35,   36,
   37,   -1,   21,   22,   23,   24,   -1,   26,   27,   28,
   29,   -1,   31,   32,   -1,   34,   -1,   54,    1,    2,
    3,    4,    5,    6,    7,    8,   63,   -1,   -1,   -1,
   49,   -1,   -1,   -1,   71,   54,   -1,   -1,   -1,   -1,
   21,   22,   23,   24,   63,   26,   27,   28,   29,   -1,
   31,   32,   71,   34,   -1,   -1,   21,   22,   23,   24,
   -1,   26,   27,   28,   29,   46,   31,   32,   -1,   34,
   -1,   -1,   -1,   54,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   46,   63,   -1,   -1,   -1,   -1,   -1,   -1,   54,
   71,   -1,   -1,   -1,   21,   22,   23,   24,   63,   26,
   27,   28,   29,   -1,   31,   32,   71,   34,   -1,   -1,
   -1,   -1,   -1,   -1,   21,   22,   23,   24,   45,   26,
   27,   28,   29,   -1,   31,   32,   -1,   34,   -1,   -1,
   -1,   -1,   -1,   -1,   61,   -1,   63,   -1,   -1,   46,
   -1,   -1,   -1,   -1,   71,   -1,   -1,   54,   -1,   -1,
   -1,   -1,   21,   22,   23,   24,   63,   26,   27,   28,
   29,   -1,   31,   32,   71,   34,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   21,   22,   23,   24,   46,   26,   27,
   28,   29,   30,   31,   32,   54,   34,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   71,   -1,   -1,   -1,   54,   -1,   -1,   -1,
   -1,   21,   22,   23,   24,   63,   26,   27,   28,   29,
   -1,   31,   32,   71,   34,    1,    2,    3,    4,    5,
    6,    7,    8,    1,    2,    3,    4,    5,    6,    7,
    8,   -1,   -1,   -1,   54,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   71,
};
#if YYBTYACC
static const YYINT yyctable[] = {                        -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,
};
#endif
#define YYFINAL 9
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 256
#define YYUNDFTOKEN 331
#define YYTRANSLATE(a) ((a) > YYMAXTOKEN ? YYUNDFTOKEN : (a))
#if YYDEBUG
static const char *const yyname[] = {

"$end","XKB_KEYMAP","XKB_KEYCODES","XKB_TYPES","XKB_SYMBOLS","XKB_COMPATMAP",
"XKB_GEOMETRY","XKB_SEMANTICS","XKB_LAYOUT",0,"INCLUDE","OVERRIDE","AUGMENT",
"REPLACE","ALTERNATE",0,0,0,0,0,"VIRTUAL_MODS","TYPE","INTERPRET","ACTION_TOK",
"KEY","ALIAS","GROUP","MODIFIER_MAP","INDICATOR","SHAPE","KEYS","ROW","SECTION",
"OVERLAY","TEXT","OUTLINE","SOLID","LOGO","VIRTUAL",0,"EQUALS","PLUS","MINUS",
"DIVIDE","TIMES","OBRACE","CBRACE","OPAREN","CPAREN","OBRACKET","CBRACKET",
"DOT","COMMA","SEMI","EXCLAM","INVERT",0,0,0,0,"STRING","INTEGER","FLOAT",
"IDENT","KEYNAME",0,0,0,0,0,"PARTIAL","DEFAULT","HIDDEN","ALPHANUMERIC_KEYS",
"MODIFIER_KEYS","KEYPAD_KEYS","FUNCTION_KEYS","ALTERNATE_GROUP",0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,"ERROR_TOK","error","$accept","XkbFile","Number","Integer",
"Float","SignedNumber","XkbCompositeType","FileType","MergeMode","OptMergeMode",
"DoodadType","Flag","Flags","OptFlags","KeyName","MapName","OptMapName",
"KeySym","FieldSpec","Ident","Element","String","DeclList","Decl","OptExprList",
"ExprList","Expr","Term","Lhs","Terminal","ArrayInit","KeySyms","OptKeySymList",
"KeySymList","Action","ActionList","Coord","CoordList","VarDecl","VarDeclList",
"SymbolsBody","SymbolsVarDecl","VModDecl","VModDefList","VModDef",
"InterpretDecl","InterpretMatch","KeyTypeDecl","SymbolsDecl","ModMapDecl",
"GroupCompatDecl","IndicatorMapDecl","IndicatorNameDecl","KeyNameDecl",
"KeyAliasDecl","ShapeDecl","SectionDecl","SectionBody","SectionBodyItem",
"RowBody","RowBodyItem","Keys","Key","OverlayDecl","OverlayKeyList",
"OverlayKey","OutlineList","OutlineInList","DoodadDecl","XkbMapConfigList",
"XkbMapConfig","XkbConfig","XkbCompositeMap","XkbCompMapList","illegal-symbol",
};
static const char *const yyrule[] = {
"$accept : XkbFile",
"XkbFile : XkbCompMapList",
"XkbFile : XkbMapConfigList",
"XkbFile : XkbConfig",
"XkbCompMapList : XkbCompMapList XkbCompositeMap",
"XkbCompMapList : XkbCompositeMap",
"XkbCompositeMap : OptFlags XkbCompositeType OptMapName OBRACE XkbMapConfigList CBRACE SEMI",
"XkbCompositeType : XKB_KEYMAP",
"XkbCompositeType : XKB_SEMANTICS",
"XkbCompositeType : XKB_LAYOUT",
"XkbMapConfigList : XkbMapConfigList XkbMapConfig",
"XkbMapConfigList : XkbMapConfig",
"XkbMapConfig : OptFlags FileType OptMapName OBRACE DeclList CBRACE SEMI",
"XkbConfig : OptFlags FileType OptMapName DeclList",
"FileType : XKB_KEYCODES",
"FileType : XKB_TYPES",
"FileType : XKB_COMPATMAP",
"FileType : XKB_SYMBOLS",
"FileType : XKB_GEOMETRY",
"OptFlags : Flags",
"OptFlags :",
"Flags : Flags Flag",
"Flags : Flag",
"Flag : PARTIAL",
"Flag : DEFAULT",
"Flag : HIDDEN",
"Flag : ALPHANUMERIC_KEYS",
"Flag : MODIFIER_KEYS",
"Flag : KEYPAD_KEYS",
"Flag : FUNCTION_KEYS",
"Flag : ALTERNATE_GROUP",
"DeclList : DeclList Decl",
"DeclList :",
"Decl : OptMergeMode VarDecl",
"Decl : OptMergeMode VModDecl",
"Decl : OptMergeMode InterpretDecl",
"Decl : OptMergeMode KeyNameDecl",
"Decl : OptMergeMode KeyAliasDecl",
"Decl : OptMergeMode KeyTypeDecl",
"Decl : OptMergeMode SymbolsDecl",
"Decl : OptMergeMode ModMapDecl",
"Decl : OptMergeMode GroupCompatDecl",
"Decl : OptMergeMode IndicatorMapDecl",
"Decl : OptMergeMode IndicatorNameDecl",
"Decl : OptMergeMode ShapeDecl",
"Decl : OptMergeMode SectionDecl",
"Decl : OptMergeMode DoodadDecl",
"Decl : MergeMode STRING",
"VarDecl : Lhs EQUALS Expr SEMI",
"VarDecl : Ident SEMI",
"VarDecl : EXCLAM Ident SEMI",
"KeyNameDecl : KeyName EQUALS Expr SEMI",
"KeyAliasDecl : ALIAS KeyName EQUALS KeyName SEMI",
"VModDecl : VIRTUAL_MODS VModDefList SEMI",
"VModDefList : VModDefList COMMA VModDef",
"VModDefList : VModDef",
"VModDef : Ident",
"VModDef : Ident EQUALS Expr",
"InterpretDecl : INTERPRET InterpretMatch OBRACE VarDeclList CBRACE SEMI",
"InterpretMatch : KeySym PLUS Expr",
"InterpretMatch : KeySym",
"VarDeclList : VarDeclList VarDecl",
"VarDeclList : VarDecl",
"KeyTypeDecl : TYPE String OBRACE VarDeclList CBRACE SEMI",
"SymbolsDecl : KEY KeyName OBRACE SymbolsBody CBRACE SEMI",
"SymbolsBody : SymbolsBody COMMA SymbolsVarDecl",
"SymbolsBody : SymbolsVarDecl",
"SymbolsBody :",
"SymbolsVarDecl : Lhs EQUALS Expr",
"SymbolsVarDecl : Lhs EQUALS ArrayInit",
"SymbolsVarDecl : Ident",
"SymbolsVarDecl : EXCLAM Ident",
"SymbolsVarDecl : ArrayInit",
"ArrayInit : OBRACKET OptKeySymList CBRACKET",
"ArrayInit : OBRACKET ActionList CBRACKET",
"GroupCompatDecl : GROUP Integer EQUALS Expr SEMI",
"ModMapDecl : MODIFIER_MAP Ident OBRACE ExprList CBRACE SEMI",
"IndicatorMapDecl : INDICATOR String OBRACE VarDeclList CBRACE SEMI",
"IndicatorNameDecl : INDICATOR Integer EQUALS Expr SEMI",
"IndicatorNameDecl : VIRTUAL INDICATOR Integer EQUALS Expr SEMI",
"ShapeDecl : SHAPE String OBRACE OutlineList CBRACE SEMI",
"ShapeDecl : SHAPE String OBRACE CoordList CBRACE SEMI",
"SectionDecl : SECTION String OBRACE SectionBody CBRACE SEMI",
"SectionBody : SectionBody SectionBodyItem",
"SectionBody : SectionBodyItem",
"SectionBodyItem : ROW OBRACE RowBody CBRACE SEMI",
"SectionBodyItem : VarDecl",
"SectionBodyItem : DoodadDecl",
"SectionBodyItem : IndicatorMapDecl",
"SectionBodyItem : OverlayDecl",
"RowBody : RowBody RowBodyItem",
"RowBody : RowBodyItem",
"RowBodyItem : KEYS OBRACE Keys CBRACE SEMI",
"RowBodyItem : VarDecl",
"Keys : Keys COMMA Key",
"Keys : Key",
"Key : KeyName",
"Key : OBRACE ExprList CBRACE",
"OverlayDecl : OVERLAY String OBRACE OverlayKeyList CBRACE SEMI",
"OverlayKeyList : OverlayKeyList COMMA OverlayKey",
"OverlayKeyList : OverlayKey",
"OverlayKey : KeyName EQUALS KeyName",
"OutlineList : OutlineList COMMA OutlineInList",
"OutlineList : OutlineInList",
"OutlineInList : OBRACE CoordList CBRACE",
"OutlineInList : Ident EQUALS OBRACE CoordList CBRACE",
"OutlineInList : Ident EQUALS Expr",
"CoordList : CoordList COMMA Coord",
"CoordList : Coord",
"Coord : OBRACKET SignedNumber COMMA SignedNumber CBRACKET",
"DoodadDecl : DoodadType String OBRACE VarDeclList CBRACE SEMI",
"DoodadType : TEXT",
"DoodadType : OUTLINE",
"DoodadType : SOLID",
"DoodadType : LOGO",
"FieldSpec : Ident",
"FieldSpec : Element",
"Element : ACTION_TOK",
"Element : INTERPRET",
"Element : TYPE",
"Element : KEY",
"Element : GROUP",
"Element : MODIFIER_MAP",
"Element : INDICATOR",
"Element : SHAPE",
"Element : ROW",
"Element : SECTION",
"Element : TEXT",
"OptMergeMode : MergeMode",
"OptMergeMode :",
"MergeMode : INCLUDE",
"MergeMode : AUGMENT",
"MergeMode : OVERRIDE",
"MergeMode : REPLACE",
"MergeMode : ALTERNATE",
"OptExprList : ExprList",
"OptExprList :",
"ExprList : ExprList COMMA Expr",
"ExprList : Expr",
"Expr : Expr DIVIDE Expr",
"Expr : Expr PLUS Expr",
"Expr : Expr MINUS Expr",
"Expr : Expr TIMES Expr",
"Expr : Lhs EQUALS Expr",
"Expr : Term",
"Term : MINUS Term",
"Term : PLUS Term",
"Term : EXCLAM Term",
"Term : INVERT Term",
"Term : Lhs",
"Term : FieldSpec OPAREN OptExprList CPAREN",
"Term : Terminal",
"Term : OPAREN Expr CPAREN",
"ActionList : ActionList COMMA Action",
"ActionList : Action",
"Action : FieldSpec OPAREN OptExprList CPAREN",
"Lhs : FieldSpec",
"Lhs : FieldSpec DOT FieldSpec",
"Lhs : FieldSpec OBRACKET Expr CBRACKET",
"Lhs : FieldSpec DOT FieldSpec OBRACKET Expr CBRACKET",
"Terminal : String",
"Terminal : Integer",
"Terminal : Float",
"Terminal : KeyName",
"OptKeySymList : KeySymList",
"OptKeySymList :",
"KeySymList : KeySymList COMMA KeySym",
"KeySymList : KeySymList COMMA KeySyms",
"KeySymList : KeySym",
"KeySymList : KeySyms",
"KeySym : IDENT",
"KeySym : SECTION",
"KeySym : Integer",
"KeySyms : OBRACE KeySymList CBRACE",
"SignedNumber : MINUS Number",
"SignedNumber : Number",
"Number : FLOAT",
"Number : INTEGER",
"Float : FLOAT",
"Integer : INTEGER",
"KeyName : KEYNAME",
"Ident : IDENT",
"Ident : DEFAULT",
"String : STRING",
"OptMapName : MapName",
"OptMapName :",
"MapName : STRING",

};
#endif

#if YYDEBUG
int      yydebug;
#endif

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;
int      yynerrs;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
YYLTYPE  yyloc; /* position returned by actions */
YYLTYPE  yylloc; /* position from the lexer */
#endif

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
#ifndef YYLLOC_DEFAULT
#define YYLLOC_DEFAULT(loc, rhs, n) \
do \
{ \
    if (n == 0) \
    { \
        (loc).first_line   = YYRHSLOC(rhs, 0).last_line; \
        (loc).first_column = YYRHSLOC(rhs, 0).last_column; \
        (loc).last_line    = YYRHSLOC(rhs, 0).last_line; \
        (loc).last_column  = YYRHSLOC(rhs, 0).last_column; \
    } \
    else \
    { \
        (loc).first_line   = YYRHSLOC(rhs, 1).first_line; \
        (loc).first_column = YYRHSLOC(rhs, 1).first_column; \
        (loc).last_line    = YYRHSLOC(rhs, n).last_line; \
        (loc).last_column  = YYRHSLOC(rhs, n).last_column; \
    } \
} while (0)
#endif /* YYLLOC_DEFAULT */
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#if YYBTYACC

#ifndef YYLVQUEUEGROWTH
#define YYLVQUEUEGROWTH 32
#endif
#endif /* YYBTYACC */

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  10000
#endif
#endif

#ifndef YYINITSTACKSIZE
#define YYINITSTACKSIZE 200
#endif

typedef struct {
    unsigned stacksize;
    YYINT    *s_base;
    YYINT    *s_mark;
    YYINT    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE  *p_base;
    YYLTYPE  *p_mark;
#endif
} YYSTACKDATA;
#if YYBTYACC

struct YYParseState_s
{
    struct YYParseState_s *save;    /* Previously saved parser state */
    YYSTACKDATA            yystack; /* saved parser stack */
    int                    state;   /* saved parser state */
    int                    errflag; /* saved error recovery status */
    int                    lexeme;  /* saved index of the conflict lexeme in the lexical queue */
    YYINT                  ctry;    /* saved index in yyctable[] for this conflict */
};
typedef struct YYParseState_s YYParseState;
#endif /* YYBTYACC */
/* variables for the parser stack */
static YYSTACKDATA yystack;
#if YYBTYACC

/* Current parser state */
static YYParseState *yyps = 0;

/* yypath != NULL: do the full parse, starting at *yypath parser state. */
static YYParseState *yypath = 0;

/* Base of the lexical value queue */
static YYSTYPE *yylvals = 0;

/* Current position at lexical value queue */
static YYSTYPE *yylvp = 0;

/* End position of lexical value queue */
static YYSTYPE *yylve = 0;

/* The last allocated position at the lexical value queue */
static YYSTYPE *yylvlim = 0;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
/* Base of the lexical position queue */
static YYLTYPE *yylpsns = 0;

/* Current position at lexical position queue */
static YYLTYPE *yylpp = 0;

/* End position of lexical position queue */
static YYLTYPE *yylpe = 0;

/* The last allocated position at the lexical position queue */
static YYLTYPE *yylplim = 0;
#endif

/* Current position at lexical token queue */
static YYINT  *yylexp = 0;

static YYINT  *yylexemes = 0;
#endif /* YYBTYACC */
#line 772 "xkbparse.y"
void
yyerror(const char *s)
{
    if (warningLevel>0) {
	(void)fprintf(stderr,"%s: line %d of %s\n",s,lineNum,
					(scanFile?scanFile:"(unknown)"));
	if ((warningLevel>3))
	    (void)fprintf(stderr,"last scanned symbol is: %s\n",scanBuf);
    }
    return;
}


int
yywrap(void)
{
   return 1;
}

#line 1114 "xkbparse.c"

/* For use in generated program */
#define yydepth (int)(yystack.s_mark - yystack.s_base)
#if YYBTYACC
#define yytrial (yyps->save)
#endif /* YYBTYACC */

#if YYDEBUG
#include <stdio.h>	/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    YYINT *newss;
    YYSTYPE *newvs;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE *newps;
#endif

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return YYENOMEM;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = (int) (data->s_mark - data->s_base);
    newss = (YYINT *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return YYENOMEM;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return YYENOMEM;

    data->l_base = newvs;
    data->l_mark = newvs + i;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    newps = (YYLTYPE *)realloc(data->p_base, newsize * sizeof(*newps));
    if (newps == 0)
        return YYENOMEM;

    data->p_base = newps;
    data->p_mark = newps + i;
#endif

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;

#if YYDEBUG
    if (yydebug)
        fprintf(stderr, "%sdebug: stack size increased to %d\n", YYPREFIX, newsize);
#endif
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    free(data->p_base);
#endif
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif /* YYPURE || defined(YY_NO_LEAKS) */
#if YYBTYACC

static YYParseState *
yyNewState(unsigned size)
{
    YYParseState *p = (YYParseState *) malloc(sizeof(YYParseState));
    if (p == NULL) return NULL;

    p->yystack.stacksize = size;
    if (size == 0)
    {
        p->yystack.s_base = NULL;
        p->yystack.l_base = NULL;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        p->yystack.p_base = NULL;
#endif
        return p;
    }
    p->yystack.s_base    = (YYINT *) malloc(size * sizeof(YYINT));
    if (p->yystack.s_base == NULL) return NULL;
    p->yystack.l_base    = (YYSTYPE *) malloc(size * sizeof(YYSTYPE));
    if (p->yystack.l_base == NULL) return NULL;
    memset(p->yystack.l_base, 0, size * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    p->yystack.p_base    = (YYLTYPE *) malloc(size * sizeof(YYLTYPE));
    if (p->yystack.p_base == NULL) return NULL;
    memset(p->yystack.p_base, 0, size * sizeof(YYLTYPE));
#endif

    return p;
}

static void
yyFreeState(YYParseState *p)
{
    yyfreestack(&p->yystack);
    free(p);
}
#endif /* YYBTYACC */

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab
#if YYBTYACC
#define YYVALID        do { if (yyps->save)            goto yyvalid; } while(0)
#define YYVALID_NESTED do { if (yyps->save && \
                                yyps->save->save == 0) goto yyvalid; } while(0)
#endif /* YYBTYACC */

int
YYPARSE_DECL()
{
    int yym, yyn, yystate, yyresult;
#if YYBTYACC
    int yynewerrflag;
    YYParseState *yyerrctx = NULL;
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE  yyerror_loc_range[3]; /* position of error start/end (0 unused) */
#endif
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
    if (yydebug)
        fprintf(stderr, "%sdebug[<# of symbols on state stack>]\n", YYPREFIX);
#endif
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    memset(yyerror_loc_range, 0, sizeof(yyerror_loc_range));
#endif

#if YYBTYACC
    yyps = yyNewState(0); if (yyps == 0) goto yyenomem;
    yyps->save = 0;
#endif /* YYBTYACC */
    yym = 0;
    /* yyn is set below */
    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark = yystack.p_base;
#endif
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
#if YYBTYACC
        do {
        if (yylvp < yylve)
        {
            /* we're currently re-reading tokens */
            yylval = *yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylloc = *yylpp++;
#endif
            yychar = *yylexp++;
            break;
        }
        if (yyps->save)
        {
            /* in trial mode; save scanner results for future parse attempts */
            if (yylvp == yylvlim)
            {   /* Enlarge lexical value queue */
                size_t p = (size_t) (yylvp - yylvals);
                size_t s = (size_t) (yylvlim - yylvals);

                s += YYLVQUEUEGROWTH;
                if ((yylexemes = (YYINT *)realloc(yylexemes, s * sizeof(YYINT))) == NULL) goto yyenomem;
                if ((yylvals   = (YYSTYPE *)realloc(yylvals, s * sizeof(YYSTYPE))) == NULL) goto yyenomem;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                if ((yylpsns   = (YYLTYPE *)realloc(yylpsns, s * sizeof(YYLTYPE))) == NULL) goto yyenomem;
#endif
                yylvp   = yylve = yylvals + p;
                yylvlim = yylvals + s;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp   = yylpe = yylpsns + p;
                yylplim = yylpsns + s;
#endif
                yylexp  = yylexemes + p;
            }
            *yylexp = (YYINT) YYLEX;
            *yylvp++ = yylval;
            yylve++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            *yylpp++ = yylloc;
            yylpe++;
#endif
            yychar = *yylexp++;
            break;
        }
        /* normal operation, no conflict encountered */
#endif /* YYBTYACC */
        yychar = YYLEX;
#if YYBTYACC
        } while (0);
#endif /* YYBTYACC */
        if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            fprintf(stderr, "%s[%d]: state %d, reading token %d (%s)",
                            YYDEBUGSTR, yydepth, yystate, yychar, yys);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
            if (!yytrial)
#endif /* YYBTYACC */
                fprintf(stderr, " <%s>", YYSTYPE_TOSTRING(yychar, yylval));
#endif
            fputc('\n', stderr);
        }
#endif
    }
#if YYBTYACC

    /* Do we have a conflict? */
    if (((yyn = yycindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
        yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        YYINT ctry;

        if (yypath)
        {
            YYParseState *save;
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%s[%d]: CONFLICT in state %d: following successful trial parse\n",
                                YYDEBUGSTR, yydepth, yystate);
#endif
            /* Switch to the next conflict context */
            save = yypath;
            yypath = save->save;
            save->save = NULL;
            ctry = save->ctry;
            if (save->state != yystate) YYABORT;
            yyFreeState(save);

        }
        else
        {

            /* Unresolved conflict - start/continue trial parse */
            YYParseState *save;
#if YYDEBUG
            if (yydebug)
            {
                fprintf(stderr, "%s[%d]: CONFLICT in state %d. ", YYDEBUGSTR, yydepth, yystate);
                if (yyps->save)
                    fputs("ALREADY in conflict, continuing trial parse.\n", stderr);
                else
                    fputs("Starting trial parse.\n", stderr);
            }
#endif
            save                  = yyNewState((unsigned)(yystack.s_mark - yystack.s_base + 1));
            if (save == NULL) goto yyenomem;
            save->save            = yyps->save;
            save->state           = yystate;
            save->errflag         = yyerrflag;
            save->yystack.s_mark  = save->yystack.s_base + (yystack.s_mark - yystack.s_base);
            memcpy (save->yystack.s_base, yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            save->yystack.l_mark  = save->yystack.l_base + (yystack.l_mark - yystack.l_base);
            memcpy (save->yystack.l_base, yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            save->yystack.p_mark  = save->yystack.p_base + (yystack.p_mark - yystack.p_base);
            memcpy (save->yystack.p_base, yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            ctry                  = yytable[yyn];
            if (yyctable[ctry] == -1)
            {
#if YYDEBUG
                if (yydebug && yychar >= YYEOF)
                    fprintf(stderr, "%s[%d]: backtracking 1 token\n", YYDEBUGSTR, yydepth);
#endif
                ctry++;
            }
            save->ctry = ctry;
            if (yyps->save == NULL)
            {
                /* If this is a first conflict in the stack, start saving lexemes */
                if (!yylexemes)
                {
                    yylexemes = (YYINT *) malloc((YYLVQUEUEGROWTH) * sizeof(YYINT));
                    if (yylexemes == NULL) goto yyenomem;
                    yylvals   = (YYSTYPE *) malloc((YYLVQUEUEGROWTH) * sizeof(YYSTYPE));
                    if (yylvals == NULL) goto yyenomem;
                    yylvlim   = yylvals + YYLVQUEUEGROWTH;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpsns   = (YYLTYPE *) malloc((YYLVQUEUEGROWTH) * sizeof(YYLTYPE));
                    if (yylpsns == NULL) goto yyenomem;
                    yylplim   = yylpsns + YYLVQUEUEGROWTH;
#endif
                }
                if (yylvp == yylve)
                {
                    yylvp  = yylve = yylvals;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpp  = yylpe = yylpsns;
#endif
                    yylexp = yylexemes;
                    if (yychar >= YYEOF)
                    {
                        *yylve++ = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                        *yylpe++ = yylloc;
#endif
                        *yylexp  = (YYINT) yychar;
                        yychar   = YYEMPTY;
                    }
                }
            }
            if (yychar >= YYEOF)
            {
                yylvp--;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp--;
#endif
                yylexp--;
                yychar = YYEMPTY;
            }
            save->lexeme = (int) (yylvp - yylvals);
            yyps->save   = save;
        }
        if (yytable[yyn] == ctry)
        {
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%s[%d]: state %d, shifting to state %d\n",
                                YYDEBUGSTR, yydepth, yystate, yyctable[ctry]);
#endif
            if (yychar < 0)
            {
                yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp++;
#endif
                yylexp++;
            }
            if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM)
                goto yyoverflow;
            yystate = yyctable[ctry];
            *++yystack.s_mark = (YYINT) yystate;
            *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            *++yystack.p_mark = yylloc;
#endif
            yychar  = YYEMPTY;
            if (yyerrflag > 0) --yyerrflag;
            goto yyloop;
        }
        else
        {
            yyn = yyctable[ctry];
            goto yyreduce;
        }
    } /* End of code dealing with conflicts */
#endif /* YYBTYACC */
    if (((yyn = yysindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
#if YYDEBUG
        if (yydebug)
            fprintf(stderr, "%s[%d]: state %d, shifting to state %d\n",
                            YYDEBUGSTR, yydepth, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        *++yystack.p_mark = yylloc;
#endif
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if (((yyn = yyrindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag != 0) goto yyinrecovery;
#if YYBTYACC

    yynewerrflag = 1;
    goto yyerrhandler;
    goto yyerrlab; /* redundant goto avoids 'unused label' warning */

yyerrlab:
    /* explicit YYERROR from an action -- pop the rhs of the rule reduced
     * before looking for error recovery */
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark -= yym;
#endif

    yynewerrflag = 0;
yyerrhandler:
    while (yyps->save)
    {
        int ctry;
        YYParseState *save = yyps->save;
#if YYDEBUG
        if (yydebug)
            fprintf(stderr, "%s[%d]: ERROR in state %d, CONFLICT BACKTRACKING to state %d, %d tokens\n",
                            YYDEBUGSTR, yydepth, yystate, yyps->save->state,
                    (int)(yylvp - yylvals - yyps->save->lexeme));
#endif
        /* Memorize most forward-looking error state in case it's really an error. */
        if (yyerrctx == NULL || yyerrctx->lexeme < yylvp - yylvals)
        {
            /* Free old saved error context state */
            if (yyerrctx) yyFreeState(yyerrctx);
            /* Create and fill out new saved error context state */
            yyerrctx                 = yyNewState((unsigned)(yystack.s_mark - yystack.s_base + 1));
            if (yyerrctx == NULL) goto yyenomem;
            yyerrctx->save           = yyps->save;
            yyerrctx->state          = yystate;
            yyerrctx->errflag        = yyerrflag;
            yyerrctx->yystack.s_mark = yyerrctx->yystack.s_base + (yystack.s_mark - yystack.s_base);
            memcpy (yyerrctx->yystack.s_base, yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            yyerrctx->yystack.l_mark = yyerrctx->yystack.l_base + (yystack.l_mark - yystack.l_base);
            memcpy (yyerrctx->yystack.l_base, yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yyerrctx->yystack.p_mark = yyerrctx->yystack.p_base + (yystack.p_mark - yystack.p_base);
            memcpy (yyerrctx->yystack.p_base, yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            yyerrctx->lexeme         = (int) (yylvp - yylvals);
        }
        yylvp          = yylvals   + save->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        yylpp          = yylpsns   + save->lexeme;
#endif
        yylexp         = yylexemes + save->lexeme;
        yychar         = YYEMPTY;
        yystack.s_mark = yystack.s_base + (save->yystack.s_mark - save->yystack.s_base);
        memcpy (yystack.s_base, save->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
        yystack.l_mark = yystack.l_base + (save->yystack.l_mark - save->yystack.l_base);
        memcpy (yystack.l_base, save->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        yystack.p_mark = yystack.p_base + (save->yystack.p_mark - save->yystack.p_base);
        memcpy (yystack.p_base, save->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
        ctry           = ++save->ctry;
        yystate        = save->state;
        /* We tried shift, try reduce now */
        if ((yyn = yyctable[ctry]) >= 0) goto yyreduce;
        yyps->save     = save->save;
        save->save     = NULL;
        yyFreeState(save);

        /* Nothing left on the stack -- error */
        if (!yyps->save)
        {
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%sdebug[%d,trial]: trial parse FAILED, entering ERROR mode\n",
                                YYPREFIX, yydepth);
#endif
            /* Restore state as it was in the most forward-advanced error */
            yylvp          = yylvals   + yyerrctx->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylpp          = yylpsns   + yyerrctx->lexeme;
#endif
            yylexp         = yylexemes + yyerrctx->lexeme;
            yychar         = yylexp[-1];
            yylval         = yylvp[-1];
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylloc         = yylpp[-1];
#endif
            yystack.s_mark = yystack.s_base + (yyerrctx->yystack.s_mark - yyerrctx->yystack.s_base);
            memcpy (yystack.s_base, yyerrctx->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            yystack.l_mark = yystack.l_base + (yyerrctx->yystack.l_mark - yyerrctx->yystack.l_base);
            memcpy (yystack.l_base, yyerrctx->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yystack.p_mark = yystack.p_base + (yyerrctx->yystack.p_mark - yyerrctx->yystack.p_base);
            memcpy (yystack.p_base, yyerrctx->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            yystate        = yyerrctx->state;
            yyFreeState(yyerrctx);
            yyerrctx       = NULL;
        }
        yynewerrflag = 1;
    }
    if (yynewerrflag == 0) goto yyinrecovery;
#endif /* YYBTYACC */

    YYERROR_CALL("syntax error");
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yyerror_loc_range[1] = yylloc; /* lookahead position is error start position */
#endif

#if !YYBTYACC
    goto yyerrlab; /* redundant goto avoids 'unused label' warning */
yyerrlab:
#endif
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if (((yyn = yysindex[*yystack.s_mark]) != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    fprintf(stderr, "%s[%d]: state %d, error recovery shifting to state %d\n",
                                    YYDEBUGSTR, yydepth, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                /* lookahead position is error end position */
                yyerror_loc_range[2] = yylloc;
                YYLLOC_DEFAULT(yyloc, yyerror_loc_range, 2); /* position of error span */
                *++yystack.p_mark = yyloc;
#endif
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    fprintf(stderr, "%s[%d]: error recovery discarding state %d\n",
                                    YYDEBUGSTR, yydepth, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                /* the current TOS position is the error start position */
                yyerror_loc_range[1] = *yystack.p_mark;
#endif
#if defined(YYDESTRUCT_CALL)
#if YYBTYACC
                if (!yytrial)
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    YYDESTRUCT_CALL("error: discarding state",
                                    yystos[*yystack.s_mark], yystack.l_mark, yystack.p_mark);
#else
                    YYDESTRUCT_CALL("error: discarding state",
                                    yystos[*yystack.s_mark], yystack.l_mark);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#endif /* defined(YYDESTRUCT_CALL) */
                --yystack.s_mark;
                --yystack.l_mark;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                --yystack.p_mark;
#endif
            }
        }
    }
    else
    {
        if (yychar == YYEOF) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            fprintf(stderr, "%s[%d]: state %d, error recovery discarding token %d (%s)\n",
                            YYDEBUGSTR, yydepth, yystate, yychar, yys);
        }
#endif
#if defined(YYDESTRUCT_CALL)
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            YYDESTRUCT_CALL("error: discarding token", yychar, &yylval, &yylloc);
#else
            YYDESTRUCT_CALL("error: discarding token", yychar, &yylval);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#endif /* defined(YYDESTRUCT_CALL) */
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
    yym = yylen[yyn];
#if YYDEBUG
    if (yydebug)
    {
        fprintf(stderr, "%s[%d]: state %d, reducing by rule %d (%s)",
                        YYDEBUGSTR, yydepth, yystate, yyn, yyrule[yyn]);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
            if (yym > 0)
            {
                int i;
                fputc('<', stderr);
                for (i = yym; i > 0; i--)
                {
                    if (i != yym) fputs(", ", stderr);
                    fputs(YYSTYPE_TOSTRING(yystos[yystack.s_mark[1-i]],
                                           yystack.l_mark[1-i]), stderr);
                }
                fputc('>', stderr);
            }
#endif
        fputc('\n', stderr);
    }
#endif
    if (yym > 0)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)

    /* Perform position reduction */
    memset(&yyloc, 0, sizeof(yyloc));
#if YYBTYACC
    if (!yytrial)
#endif /* YYBTYACC */
    {
        YYLLOC_DEFAULT(yyloc, &yystack.p_mark[-yym], yym);
        /* just in case YYERROR is invoked within the action, save
           the start of the rhs as the error start position */
        yyerror_loc_range[1] = yystack.p_mark[1-yym];
    }
#endif

    switch (yyn)
    {
case 1:
#line 169 "xkbparse.y"
	{ yyval.file= rtrnValue= yystack.l_mark[0].file; }
#line 1787 "xkbparse.c"
break;
case 2:
#line 171 "xkbparse.y"
	{ yyval.file= rtrnValue= yystack.l_mark[0].file;  }
#line 1792 "xkbparse.c"
break;
case 3:
#line 173 "xkbparse.y"
	{ yyval.file= rtrnValue= yystack.l_mark[0].file; }
#line 1797 "xkbparse.c"
break;
case 4:
#line 177 "xkbparse.y"
	{ yyval.file= (XkbFile *)AppendStmt(&yystack.l_mark[-1].file->common,&yystack.l_mark[0].file->common); }
#line 1802 "xkbparse.c"
break;
case 5:
#line 179 "xkbparse.y"
	{ yyval.file= yystack.l_mark[0].file; }
#line 1807 "xkbparse.c"
break;
case 6:
#line 185 "xkbparse.y"
	{ yyval.file= CreateXKBFile(yystack.l_mark[-5].uval,yystack.l_mark[-4].str,&yystack.l_mark[-2].file->common,yystack.l_mark[-6].uval); }
#line 1812 "xkbparse.c"
break;
case 7:
#line 188 "xkbparse.y"
	{ yyval.uval= XkmKeymapFile; }
#line 1817 "xkbparse.c"
break;
case 8:
#line 189 "xkbparse.y"
	{ yyval.uval= XkmSemanticsFile; }
#line 1822 "xkbparse.c"
break;
case 9:
#line 190 "xkbparse.y"
	{ yyval.uval= XkmLayoutFile; }
#line 1827 "xkbparse.c"
break;
case 10:
#line 194 "xkbparse.y"
	{ yyval.file= (XkbFile *)AppendStmt(&yystack.l_mark[-1].file->common,&yystack.l_mark[0].file->common); }
#line 1832 "xkbparse.c"
break;
case 11:
#line 196 "xkbparse.y"
	{ yyval.file= yystack.l_mark[0].file; }
#line 1837 "xkbparse.c"
break;
case 12:
#line 202 "xkbparse.y"
	{ yyval.file= CreateXKBFile(yystack.l_mark[-5].uval,yystack.l_mark[-4].str,yystack.l_mark[-2].any,yystack.l_mark[-6].uval); }
#line 1842 "xkbparse.c"
break;
case 13:
#line 206 "xkbparse.y"
	{ yyval.file= CreateXKBFile(yystack.l_mark[-2].uval,yystack.l_mark[-1].str,yystack.l_mark[0].any,yystack.l_mark[-3].uval); }
#line 1847 "xkbparse.c"
break;
case 14:
#line 210 "xkbparse.y"
	{ yyval.uval= XkmKeyNamesIndex; }
#line 1852 "xkbparse.c"
break;
case 15:
#line 211 "xkbparse.y"
	{ yyval.uval= XkmTypesIndex; }
#line 1857 "xkbparse.c"
break;
case 16:
#line 212 "xkbparse.y"
	{ yyval.uval= XkmCompatMapIndex; }
#line 1862 "xkbparse.c"
break;
case 17:
#line 213 "xkbparse.y"
	{ yyval.uval= XkmSymbolsIndex; }
#line 1867 "xkbparse.c"
break;
case 18:
#line 214 "xkbparse.y"
	{ yyval.uval= XkmGeometryIndex; }
#line 1872 "xkbparse.c"
break;
case 19:
#line 217 "xkbparse.y"
	{ yyval.uval= yystack.l_mark[0].uval; }
#line 1877 "xkbparse.c"
break;
case 20:
#line 218 "xkbparse.y"
	{ yyval.uval= 0; }
#line 1882 "xkbparse.c"
break;
case 21:
#line 221 "xkbparse.y"
	{ yyval.uval= ((yystack.l_mark[-1].uval)|(yystack.l_mark[0].uval)); }
#line 1887 "xkbparse.c"
break;
case 22:
#line 222 "xkbparse.y"
	{ yyval.uval= yystack.l_mark[0].uval; }
#line 1892 "xkbparse.c"
break;
case 23:
#line 225 "xkbparse.y"
	{ yyval.uval= XkbLC_Partial; }
#line 1897 "xkbparse.c"
break;
case 24:
#line 226 "xkbparse.y"
	{ yyval.uval= XkbLC_Default; }
#line 1902 "xkbparse.c"
break;
case 25:
#line 227 "xkbparse.y"
	{ yyval.uval= XkbLC_Hidden; }
#line 1907 "xkbparse.c"
break;
case 26:
#line 228 "xkbparse.y"
	{ yyval.uval= XkbLC_AlphanumericKeys; }
#line 1912 "xkbparse.c"
break;
case 27:
#line 229 "xkbparse.y"
	{ yyval.uval= XkbLC_ModifierKeys; }
#line 1917 "xkbparse.c"
break;
case 28:
#line 230 "xkbparse.y"
	{ yyval.uval= XkbLC_KeypadKeys; }
#line 1922 "xkbparse.c"
break;
case 29:
#line 231 "xkbparse.y"
	{ yyval.uval= XkbLC_FunctionKeys; }
#line 1927 "xkbparse.c"
break;
case 30:
#line 232 "xkbparse.y"
	{ yyval.uval= XkbLC_AlternateGroup; }
#line 1932 "xkbparse.c"
break;
case 31:
#line 236 "xkbparse.y"
	{ yyval.any= AppendStmt(yystack.l_mark[-1].any,yystack.l_mark[0].any); }
#line 1937 "xkbparse.c"
break;
case 32:
#line 237 "xkbparse.y"
	{ yyval.any= NULL; }
#line 1942 "xkbparse.c"
break;
case 33:
#line 241 "xkbparse.y"
	{
			    yystack.l_mark[0].var->merge= StmtSetMerge(&yystack.l_mark[0].var->common,yystack.l_mark[-1].uval);
			    yyval.any= &yystack.l_mark[0].var->common;
			}
#line 1950 "xkbparse.c"
break;
case 34:
#line 246 "xkbparse.y"
	{
			    yystack.l_mark[0].vmod->merge= StmtSetMerge(&yystack.l_mark[0].vmod->common,yystack.l_mark[-1].uval);
			    yyval.any= &yystack.l_mark[0].vmod->common;
			}
#line 1958 "xkbparse.c"
break;
case 35:
#line 251 "xkbparse.y"
	{
			    yystack.l_mark[0].interp->merge= StmtSetMerge(&yystack.l_mark[0].interp->common,yystack.l_mark[-1].uval);
			    yyval.any= &yystack.l_mark[0].interp->common;
			}
#line 1966 "xkbparse.c"
break;
case 36:
#line 256 "xkbparse.y"
	{
			    yystack.l_mark[0].keyName->merge= StmtSetMerge(&yystack.l_mark[0].keyName->common,yystack.l_mark[-1].uval);
			    yyval.any= &yystack.l_mark[0].keyName->common;
			}
#line 1974 "xkbparse.c"
break;
case 37:
#line 261 "xkbparse.y"
	{
			    yystack.l_mark[0].keyAlias->merge= StmtSetMerge(&yystack.l_mark[0].keyAlias->common,yystack.l_mark[-1].uval);
			    yyval.any= &yystack.l_mark[0].keyAlias->common;
			}
#line 1982 "xkbparse.c"
break;
case 38:
#line 266 "xkbparse.y"
	{
			    yystack.l_mark[0].keyType->merge= StmtSetMerge(&yystack.l_mark[0].keyType->common,yystack.l_mark[-1].uval);
			    yyval.any= &yystack.l_mark[0].keyType->common;
			}
#line 1990 "xkbparse.c"
break;
case 39:
#line 271 "xkbparse.y"
	{
			    yystack.l_mark[0].syms->merge= StmtSetMerge(&yystack.l_mark[0].syms->common,yystack.l_mark[-1].uval);
			    yyval.any= &yystack.l_mark[0].syms->common;
			}
#line 1998 "xkbparse.c"
break;
case 40:
#line 276 "xkbparse.y"
	{
			    yystack.l_mark[0].modMask->merge= StmtSetMerge(&yystack.l_mark[0].modMask->common,yystack.l_mark[-1].uval);
			    yyval.any= &yystack.l_mark[0].modMask->common;
			}
#line 2006 "xkbparse.c"
break;
case 41:
#line 281 "xkbparse.y"
	{
			    yystack.l_mark[0].groupCompat->merge= StmtSetMerge(&yystack.l_mark[0].groupCompat->common,yystack.l_mark[-1].uval);
			    yyval.any= &yystack.l_mark[0].groupCompat->common;
			}
#line 2014 "xkbparse.c"
break;
case 42:
#line 286 "xkbparse.y"
	{
			    yystack.l_mark[0].ledMap->merge= StmtSetMerge(&yystack.l_mark[0].ledMap->common,yystack.l_mark[-1].uval);
			    yyval.any= &yystack.l_mark[0].ledMap->common;
			}
#line 2022 "xkbparse.c"
break;
case 43:
#line 291 "xkbparse.y"
	{
			    yystack.l_mark[0].ledName->merge= StmtSetMerge(&yystack.l_mark[0].ledName->common,yystack.l_mark[-1].uval);
			    yyval.any= &yystack.l_mark[0].ledName->common;
			}
#line 2030 "xkbparse.c"
break;
case 44:
#line 296 "xkbparse.y"
	{
			    yystack.l_mark[0].shape->merge= StmtSetMerge(&yystack.l_mark[0].shape->common,yystack.l_mark[-1].uval);
			    yyval.any= &yystack.l_mark[0].shape->common;
			}
#line 2038 "xkbparse.c"
break;
case 45:
#line 301 "xkbparse.y"
	{
			    yystack.l_mark[0].section->merge= StmtSetMerge(&yystack.l_mark[0].section->common,yystack.l_mark[-1].uval);
			    yyval.any= &yystack.l_mark[0].section->common;
			}
#line 2046 "xkbparse.c"
break;
case 46:
#line 306 "xkbparse.y"
	{
			    yystack.l_mark[0].doodad->merge= StmtSetMerge(&yystack.l_mark[0].doodad->common,yystack.l_mark[-1].uval);
			    yyval.any= &yystack.l_mark[0].doodad->common;
			}
#line 2054 "xkbparse.c"
break;
case 47:
#line 311 "xkbparse.y"
	{
			    if (yystack.l_mark[-1].uval==MergeAltForm) {
				yyerror("cannot use 'alternate' to include other maps");
				yyval.any= &IncludeCreate(scanBuf,MergeDefault)->common;
			    }
			    else {
				yyval.any= &IncludeCreate(scanBuf,yystack.l_mark[-1].uval)->common;
			    }
                        }
#line 2067 "xkbparse.c"
break;
case 48:
#line 323 "xkbparse.y"
	{ yyval.var= VarCreate(yystack.l_mark[-3].expr,yystack.l_mark[-1].expr); }
#line 2072 "xkbparse.c"
break;
case 49:
#line 325 "xkbparse.y"
	{ yyval.var= BoolVarCreate(yystack.l_mark[-1].sval,1); }
#line 2077 "xkbparse.c"
break;
case 50:
#line 327 "xkbparse.y"
	{ yyval.var= BoolVarCreate(yystack.l_mark[-1].sval,0); }
#line 2082 "xkbparse.c"
break;
case 51:
#line 331 "xkbparse.y"
	{
			    KeycodeDef *def;

			    def= KeycodeCreate(yystack.l_mark[-3].str,yystack.l_mark[-1].expr);
			    if (yystack.l_mark[-3].str)
				free(yystack.l_mark[-3].str);
			    yyval.keyName= def;
			}
#line 2094 "xkbparse.c"
break;
case 52:
#line 342 "xkbparse.y"
	{
			    KeyAliasDef	*def;
			    def= KeyAliasCreate(yystack.l_mark[-3].str,yystack.l_mark[-1].str);
			    if (yystack.l_mark[-3].str)	free(yystack.l_mark[-3].str);	
			    if (yystack.l_mark[-1].str)	free(yystack.l_mark[-1].str);	
			    yyval.keyAlias= def;
			}
#line 2105 "xkbparse.c"
break;
case 53:
#line 352 "xkbparse.y"
	{ yyval.vmod= yystack.l_mark[-1].vmod; }
#line 2110 "xkbparse.c"
break;
case 54:
#line 356 "xkbparse.y"
	{ yyval.vmod= (VModDef *)AppendStmt(&yystack.l_mark[-2].vmod->common,&yystack.l_mark[0].vmod->common); }
#line 2115 "xkbparse.c"
break;
case 55:
#line 358 "xkbparse.y"
	{ yyval.vmod= yystack.l_mark[0].vmod; }
#line 2120 "xkbparse.c"
break;
case 56:
#line 362 "xkbparse.y"
	{ yyval.vmod= VModCreate(yystack.l_mark[0].sval,NULL); }
#line 2125 "xkbparse.c"
break;
case 57:
#line 364 "xkbparse.y"
	{ yyval.vmod= VModCreate(yystack.l_mark[-2].sval,yystack.l_mark[0].expr); }
#line 2130 "xkbparse.c"
break;
case 58:
#line 370 "xkbparse.y"
	{
			    yystack.l_mark[-4].interp->def= yystack.l_mark[-2].var;
			    yyval.interp= yystack.l_mark[-4].interp;
			}
#line 2138 "xkbparse.c"
break;
case 59:
#line 377 "xkbparse.y"
	{ yyval.interp= InterpCreate(yystack.l_mark[-2].str, yystack.l_mark[0].expr); }
#line 2143 "xkbparse.c"
break;
case 60:
#line 379 "xkbparse.y"
	{ yyval.interp= InterpCreate(yystack.l_mark[0].str, NULL); }
#line 2148 "xkbparse.c"
break;
case 61:
#line 383 "xkbparse.y"
	{ yyval.var= (VarDef *)AppendStmt(&yystack.l_mark[-1].var->common,&yystack.l_mark[0].var->common); }
#line 2153 "xkbparse.c"
break;
case 62:
#line 385 "xkbparse.y"
	{ yyval.var= yystack.l_mark[0].var; }
#line 2158 "xkbparse.c"
break;
case 63:
#line 391 "xkbparse.y"
	{ yyval.keyType= KeyTypeCreate(yystack.l_mark[-4].sval,yystack.l_mark[-2].var); }
#line 2163 "xkbparse.c"
break;
case 64:
#line 397 "xkbparse.y"
	{ yyval.syms= SymbolsCreate(yystack.l_mark[-4].str,(ExprDef *)yystack.l_mark[-2].var); }
#line 2168 "xkbparse.c"
break;
case 65:
#line 401 "xkbparse.y"
	{ yyval.var= (VarDef *)AppendStmt(&yystack.l_mark[-2].var->common,&yystack.l_mark[0].var->common); }
#line 2173 "xkbparse.c"
break;
case 66:
#line 403 "xkbparse.y"
	{ yyval.var= yystack.l_mark[0].var; }
#line 2178 "xkbparse.c"
break;
case 67:
#line 404 "xkbparse.y"
	{ yyval.var= NULL; }
#line 2183 "xkbparse.c"
break;
case 68:
#line 408 "xkbparse.y"
	{ yyval.var= VarCreate(yystack.l_mark[-2].expr,yystack.l_mark[0].expr); }
#line 2188 "xkbparse.c"
break;
case 69:
#line 410 "xkbparse.y"
	{ yyval.var= VarCreate(yystack.l_mark[-2].expr,yystack.l_mark[0].expr); }
#line 2193 "xkbparse.c"
break;
case 70:
#line 412 "xkbparse.y"
	{ yyval.var= BoolVarCreate(yystack.l_mark[0].sval,1); }
#line 2198 "xkbparse.c"
break;
case 71:
#line 414 "xkbparse.y"
	{ yyval.var= BoolVarCreate(yystack.l_mark[0].sval,0); }
#line 2203 "xkbparse.c"
break;
case 72:
#line 416 "xkbparse.y"
	{ yyval.var= VarCreate(NULL,yystack.l_mark[0].expr); }
#line 2208 "xkbparse.c"
break;
case 73:
#line 420 "xkbparse.y"
	{ yyval.expr= yystack.l_mark[-1].expr; }
#line 2213 "xkbparse.c"
break;
case 74:
#line 422 "xkbparse.y"
	{ yyval.expr= ExprCreateUnary(ExprActionList,TypeAction,yystack.l_mark[-1].expr); }
#line 2218 "xkbparse.c"
break;
case 75:
#line 426 "xkbparse.y"
	{ yyval.groupCompat= GroupCompatCreate(yystack.l_mark[-3].ival,yystack.l_mark[-1].expr); }
#line 2223 "xkbparse.c"
break;
case 76:
#line 430 "xkbparse.y"
	{ yyval.modMask= ModMapCreate(yystack.l_mark[-4].sval,yystack.l_mark[-2].expr); }
#line 2228 "xkbparse.c"
break;
case 77:
#line 434 "xkbparse.y"
	{ yyval.ledMap= IndicatorMapCreate(yystack.l_mark[-4].sval,yystack.l_mark[-2].var); }
#line 2233 "xkbparse.c"
break;
case 78:
#line 438 "xkbparse.y"
	{ yyval.ledName= IndicatorNameCreate(yystack.l_mark[-3].ival,yystack.l_mark[-1].expr,False); }
#line 2238 "xkbparse.c"
break;
case 79:
#line 440 "xkbparse.y"
	{ yyval.ledName= IndicatorNameCreate(yystack.l_mark[-3].ival,yystack.l_mark[-1].expr,True); }
#line 2243 "xkbparse.c"
break;
case 80:
#line 444 "xkbparse.y"
	{ yyval.shape= ShapeDeclCreate(yystack.l_mark[-4].sval,(OutlineDef *)&yystack.l_mark[-2].outline->common); }
#line 2248 "xkbparse.c"
break;
case 81:
#line 446 "xkbparse.y"
	{
			    OutlineDef *outlines;
			    outlines= OutlineCreate(None,yystack.l_mark[-2].expr);
			    yyval.shape= ShapeDeclCreate(yystack.l_mark[-4].sval,outlines);
			}
#line 2257 "xkbparse.c"
break;
case 82:
#line 454 "xkbparse.y"
	{ yyval.section= SectionDeclCreate(yystack.l_mark[-4].sval,yystack.l_mark[-2].row); }
#line 2262 "xkbparse.c"
break;
case 83:
#line 458 "xkbparse.y"
	{ yyval.row=(RowDef *)AppendStmt(&yystack.l_mark[-1].row->common,&yystack.l_mark[0].row->common);}
#line 2267 "xkbparse.c"
break;
case 84:
#line 460 "xkbparse.y"
	{ yyval.row= yystack.l_mark[0].row; }
#line 2272 "xkbparse.c"
break;
case 85:
#line 464 "xkbparse.y"
	{ yyval.row= RowDeclCreate(yystack.l_mark[-2].key); }
#line 2277 "xkbparse.c"
break;
case 86:
#line 466 "xkbparse.y"
	{ yyval.row= (RowDef *)yystack.l_mark[0].var; }
#line 2282 "xkbparse.c"
break;
case 87:
#line 468 "xkbparse.y"
	{ yyval.row= (RowDef *)yystack.l_mark[0].doodad; }
#line 2287 "xkbparse.c"
break;
case 88:
#line 470 "xkbparse.y"
	{ yyval.row= (RowDef *)yystack.l_mark[0].ledMap; }
#line 2292 "xkbparse.c"
break;
case 89:
#line 472 "xkbparse.y"
	{ yyval.row= (RowDef *)yystack.l_mark[0].overlay; }
#line 2297 "xkbparse.c"
break;
case 90:
#line 476 "xkbparse.y"
	{ yyval.key=(KeyDef *)AppendStmt(&yystack.l_mark[-1].key->common,&yystack.l_mark[0].key->common);}
#line 2302 "xkbparse.c"
break;
case 91:
#line 478 "xkbparse.y"
	{ yyval.key= yystack.l_mark[0].key; }
#line 2307 "xkbparse.c"
break;
case 92:
#line 482 "xkbparse.y"
	{ yyval.key= yystack.l_mark[-2].key; }
#line 2312 "xkbparse.c"
break;
case 93:
#line 484 "xkbparse.y"
	{ yyval.key= (KeyDef *)yystack.l_mark[0].var; }
#line 2317 "xkbparse.c"
break;
case 94:
#line 488 "xkbparse.y"
	{ yyval.key=(KeyDef *)AppendStmt(&yystack.l_mark[-2].key->common,&yystack.l_mark[0].key->common);}
#line 2322 "xkbparse.c"
break;
case 95:
#line 490 "xkbparse.y"
	{ yyval.key= yystack.l_mark[0].key; }
#line 2327 "xkbparse.c"
break;
case 96:
#line 494 "xkbparse.y"
	{ yyval.key= KeyDeclCreate(yystack.l_mark[0].str,NULL); }
#line 2332 "xkbparse.c"
break;
case 97:
#line 496 "xkbparse.y"
	{ yyval.key= KeyDeclCreate(NULL,yystack.l_mark[-1].expr); }
#line 2337 "xkbparse.c"
break;
case 98:
#line 500 "xkbparse.y"
	{ yyval.overlay= OverlayDeclCreate(yystack.l_mark[-4].sval,yystack.l_mark[-2].olKey); }
#line 2342 "xkbparse.c"
break;
case 99:
#line 504 "xkbparse.y"
	{
			    yyval.olKey= (OverlayKeyDef *)
				AppendStmt(&yystack.l_mark[-2].olKey->common,&yystack.l_mark[0].olKey->common);
			}
#line 2350 "xkbparse.c"
break;
case 100:
#line 509 "xkbparse.y"
	{ yyval.olKey= yystack.l_mark[0].olKey; }
#line 2355 "xkbparse.c"
break;
case 101:
#line 513 "xkbparse.y"
	{ yyval.olKey= OverlayKeyCreate(yystack.l_mark[-2].str,yystack.l_mark[0].str); }
#line 2360 "xkbparse.c"
break;
case 102:
#line 517 "xkbparse.y"
	{ yyval.outline=(OutlineDef *)AppendStmt(&yystack.l_mark[-2].outline->common,&yystack.l_mark[0].outline->common);}
#line 2365 "xkbparse.c"
break;
case 103:
#line 519 "xkbparse.y"
	{ yyval.outline= yystack.l_mark[0].outline; }
#line 2370 "xkbparse.c"
break;
case 104:
#line 523 "xkbparse.y"
	{ yyval.outline= OutlineCreate(None,yystack.l_mark[-1].expr); }
#line 2375 "xkbparse.c"
break;
case 105:
#line 525 "xkbparse.y"
	{ yyval.outline= OutlineCreate(yystack.l_mark[-4].sval,yystack.l_mark[-1].expr); }
#line 2380 "xkbparse.c"
break;
case 106:
#line 527 "xkbparse.y"
	{ yyval.outline= OutlineCreate(yystack.l_mark[-2].sval,yystack.l_mark[0].expr); }
#line 2385 "xkbparse.c"
break;
case 107:
#line 531 "xkbparse.y"
	{ yyval.expr= (ExprDef *)AppendStmt(&yystack.l_mark[-2].expr->common,&yystack.l_mark[0].expr->common); }
#line 2390 "xkbparse.c"
break;
case 108:
#line 533 "xkbparse.y"
	{ yyval.expr= yystack.l_mark[0].expr; }
#line 2395 "xkbparse.c"
break;
case 109:
#line 537 "xkbparse.y"
	{
			    ExprDef *expr;
			    expr= ExprCreate(ExprCoord,TypeUnknown);
			    expr->value.coord.x= yystack.l_mark[-3].ival;
			    expr->value.coord.y= yystack.l_mark[-1].ival;
			    yyval.expr= expr;
			}
#line 2406 "xkbparse.c"
break;
case 110:
#line 547 "xkbparse.y"
	{ yyval.doodad= DoodadCreate(yystack.l_mark[-5].uval,yystack.l_mark[-4].sval,yystack.l_mark[-2].var); }
#line 2411 "xkbparse.c"
break;
case 111:
#line 550 "xkbparse.y"
	{ yyval.uval= XkbTextDoodad; }
#line 2416 "xkbparse.c"
break;
case 112:
#line 551 "xkbparse.y"
	{ yyval.uval= XkbOutlineDoodad; }
#line 2421 "xkbparse.c"
break;
case 113:
#line 552 "xkbparse.y"
	{ yyval.uval= XkbSolidDoodad; }
#line 2426 "xkbparse.c"
break;
case 114:
#line 553 "xkbparse.y"
	{ yyval.uval= XkbLogoDoodad; }
#line 2431 "xkbparse.c"
break;
case 115:
#line 556 "xkbparse.y"
	{ yyval.sval= yystack.l_mark[0].sval; }
#line 2436 "xkbparse.c"
break;
case 116:
#line 557 "xkbparse.y"
	{ yyval.sval= yystack.l_mark[0].sval; }
#line 2441 "xkbparse.c"
break;
case 117:
#line 561 "xkbparse.y"
	{ yyval.sval= XkbInternAtom(NULL,"action",False); }
#line 2446 "xkbparse.c"
break;
case 118:
#line 563 "xkbparse.y"
	{ yyval.sval= XkbInternAtom(NULL,"interpret",False); }
#line 2451 "xkbparse.c"
break;
case 119:
#line 565 "xkbparse.y"
	{ yyval.sval= XkbInternAtom(NULL,"type",False); }
#line 2456 "xkbparse.c"
break;
case 120:
#line 567 "xkbparse.y"
	{ yyval.sval= XkbInternAtom(NULL,"key",False); }
#line 2461 "xkbparse.c"
break;
case 121:
#line 569 "xkbparse.y"
	{ yyval.sval= XkbInternAtom(NULL,"group",False); }
#line 2466 "xkbparse.c"
break;
case 122:
#line 571 "xkbparse.y"
	{yyval.sval=XkbInternAtom(NULL,"modifier_map",False);}
#line 2471 "xkbparse.c"
break;
case 123:
#line 573 "xkbparse.y"
	{ yyval.sval= XkbInternAtom(NULL,"indicator",False); }
#line 2476 "xkbparse.c"
break;
case 124:
#line 575 "xkbparse.y"
	{ yyval.sval= XkbInternAtom(NULL,"shape",False); }
#line 2481 "xkbparse.c"
break;
case 125:
#line 577 "xkbparse.y"
	{ yyval.sval= XkbInternAtom(NULL,"row",False); }
#line 2486 "xkbparse.c"
break;
case 126:
#line 579 "xkbparse.y"
	{ yyval.sval= XkbInternAtom(NULL,"section",False); }
#line 2491 "xkbparse.c"
break;
case 127:
#line 581 "xkbparse.y"
	{ yyval.sval= XkbInternAtom(NULL,"text",False); }
#line 2496 "xkbparse.c"
break;
case 128:
#line 584 "xkbparse.y"
	{ yyval.uval= yystack.l_mark[0].uval; }
#line 2501 "xkbparse.c"
break;
case 129:
#line 585 "xkbparse.y"
	{ yyval.uval= MergeDefault; }
#line 2506 "xkbparse.c"
break;
case 130:
#line 588 "xkbparse.y"
	{ yyval.uval= MergeDefault; }
#line 2511 "xkbparse.c"
break;
case 131:
#line 589 "xkbparse.y"
	{ yyval.uval= MergeAugment; }
#line 2516 "xkbparse.c"
break;
case 132:
#line 590 "xkbparse.y"
	{ yyval.uval= MergeOverride; }
#line 2521 "xkbparse.c"
break;
case 133:
#line 591 "xkbparse.y"
	{ yyval.uval= MergeReplace; }
#line 2526 "xkbparse.c"
break;
case 134:
#line 592 "xkbparse.y"
	{ yyval.uval= MergeAltForm; }
#line 2531 "xkbparse.c"
break;
case 135:
#line 595 "xkbparse.y"
	{ yyval.expr= yystack.l_mark[0].expr; }
#line 2536 "xkbparse.c"
break;
case 136:
#line 596 "xkbparse.y"
	{ yyval.expr= NULL; }
#line 2541 "xkbparse.c"
break;
case 137:
#line 600 "xkbparse.y"
	{ yyval.expr= (ExprDef *)AppendStmt(&yystack.l_mark[-2].expr->common,&yystack.l_mark[0].expr->common); }
#line 2546 "xkbparse.c"
break;
case 138:
#line 602 "xkbparse.y"
	{ yyval.expr= yystack.l_mark[0].expr; }
#line 2551 "xkbparse.c"
break;
case 139:
#line 606 "xkbparse.y"
	{ yyval.expr= ExprCreateBinary(OpDivide,yystack.l_mark[-2].expr,yystack.l_mark[0].expr); }
#line 2556 "xkbparse.c"
break;
case 140:
#line 608 "xkbparse.y"
	{ yyval.expr= ExprCreateBinary(OpAdd,yystack.l_mark[-2].expr,yystack.l_mark[0].expr); }
#line 2561 "xkbparse.c"
break;
case 141:
#line 610 "xkbparse.y"
	{ yyval.expr= ExprCreateBinary(OpSubtract,yystack.l_mark[-2].expr,yystack.l_mark[0].expr); }
#line 2566 "xkbparse.c"
break;
case 142:
#line 612 "xkbparse.y"
	{ yyval.expr= ExprCreateBinary(OpMultiply,yystack.l_mark[-2].expr,yystack.l_mark[0].expr); }
#line 2571 "xkbparse.c"
break;
case 143:
#line 614 "xkbparse.y"
	{ yyval.expr= ExprCreateBinary(OpAssign,yystack.l_mark[-2].expr,yystack.l_mark[0].expr); }
#line 2576 "xkbparse.c"
break;
case 144:
#line 616 "xkbparse.y"
	{ yyval.expr= yystack.l_mark[0].expr; }
#line 2581 "xkbparse.c"
break;
case 145:
#line 620 "xkbparse.y"
	{ yyval.expr= ExprCreateUnary(OpNegate,yystack.l_mark[0].expr->type,yystack.l_mark[0].expr); }
#line 2586 "xkbparse.c"
break;
case 146:
#line 622 "xkbparse.y"
	{ yyval.expr= ExprCreateUnary(OpUnaryPlus,yystack.l_mark[0].expr->type,yystack.l_mark[0].expr); }
#line 2591 "xkbparse.c"
break;
case 147:
#line 624 "xkbparse.y"
	{ yyval.expr= ExprCreateUnary(OpNot,TypeBoolean,yystack.l_mark[0].expr); }
#line 2596 "xkbparse.c"
break;
case 148:
#line 626 "xkbparse.y"
	{ yyval.expr= ExprCreateUnary(OpInvert,yystack.l_mark[0].expr->type,yystack.l_mark[0].expr); }
#line 2601 "xkbparse.c"
break;
case 149:
#line 628 "xkbparse.y"
	{ yyval.expr= yystack.l_mark[0].expr;  }
#line 2606 "xkbparse.c"
break;
case 150:
#line 630 "xkbparse.y"
	{ yyval.expr= ActionCreate(yystack.l_mark[-3].sval,yystack.l_mark[-1].expr); }
#line 2611 "xkbparse.c"
break;
case 151:
#line 632 "xkbparse.y"
	{ yyval.expr= yystack.l_mark[0].expr;  }
#line 2616 "xkbparse.c"
break;
case 152:
#line 634 "xkbparse.y"
	{ yyval.expr= yystack.l_mark[-1].expr;  }
#line 2621 "xkbparse.c"
break;
case 153:
#line 638 "xkbparse.y"
	{ yyval.expr= (ExprDef *)AppendStmt(&yystack.l_mark[-2].expr->common,&yystack.l_mark[0].expr->common); }
#line 2626 "xkbparse.c"
break;
case 154:
#line 640 "xkbparse.y"
	{ yyval.expr= yystack.l_mark[0].expr; }
#line 2631 "xkbparse.c"
break;
case 155:
#line 644 "xkbparse.y"
	{ yyval.expr= ActionCreate(yystack.l_mark[-3].sval,yystack.l_mark[-1].expr); }
#line 2636 "xkbparse.c"
break;
case 156:
#line 648 "xkbparse.y"
	{
			    ExprDef *expr;
                            expr= ExprCreate(ExprIdent,TypeUnknown);
                            expr->value.str= yystack.l_mark[0].sval;
                            yyval.expr= expr;
			}
#line 2646 "xkbparse.c"
break;
case 157:
#line 655 "xkbparse.y"
	{
                            ExprDef *expr;
                            expr= ExprCreate(ExprFieldRef,TypeUnknown);
                            expr->value.field.element= yystack.l_mark[-2].sval;
                            expr->value.field.field= yystack.l_mark[0].sval;
                            yyval.expr= expr;
			}
#line 2657 "xkbparse.c"
break;
case 158:
#line 663 "xkbparse.y"
	{
			    ExprDef *expr;
			    expr= ExprCreate(ExprArrayRef,TypeUnknown);
			    expr->value.array.element= None;
			    expr->value.array.field= yystack.l_mark[-3].sval;
			    expr->value.array.entry= yystack.l_mark[-1].expr;
			    yyval.expr= expr;
			}
#line 2669 "xkbparse.c"
break;
case 159:
#line 672 "xkbparse.y"
	{
			    ExprDef *expr;
			    expr= ExprCreate(ExprArrayRef,TypeUnknown);
			    expr->value.array.element= yystack.l_mark[-5].sval;
			    expr->value.array.field= yystack.l_mark[-3].sval;
			    expr->value.array.entry= yystack.l_mark[-1].expr;
			    yyval.expr= expr;
			}
#line 2681 "xkbparse.c"
break;
case 160:
#line 683 "xkbparse.y"
	{
			    ExprDef *expr;
                            expr= ExprCreate(ExprValue,TypeString);
                            expr->value.str= yystack.l_mark[0].sval;
                            yyval.expr= expr;
			}
#line 2691 "xkbparse.c"
break;
case 161:
#line 690 "xkbparse.y"
	{
			    ExprDef *expr;
                            expr= ExprCreate(ExprValue,TypeInt);
                            expr->value.ival= yystack.l_mark[0].ival;
                            yyval.expr= expr;
			}
#line 2701 "xkbparse.c"
break;
case 162:
#line 697 "xkbparse.y"
	{
			    ExprDef *expr;
			    expr= ExprCreate(ExprValue,TypeFloat);
			    expr->value.ival= yystack.l_mark[0].ival;
			    yyval.expr= expr;
			}
#line 2711 "xkbparse.c"
break;
case 163:
#line 704 "xkbparse.y"
	{
			    ExprDef *expr;
			    expr= ExprCreate(ExprValue,TypeKeyName);
			    memset(expr->value.keyName,0,5);
			    strncpy(expr->value.keyName,yystack.l_mark[0].str,4);
			    free(yystack.l_mark[0].str);
			    yyval.expr= expr;
			}
#line 2723 "xkbparse.c"
break;
case 164:
#line 714 "xkbparse.y"
	{ yyval.expr= yystack.l_mark[0].expr; }
#line 2728 "xkbparse.c"
break;
case 165:
#line 715 "xkbparse.y"
	{ yyval.expr= NULL; }
#line 2733 "xkbparse.c"
break;
case 166:
#line 719 "xkbparse.y"
	{ yyval.expr= AppendKeysymList(yystack.l_mark[-2].expr,yystack.l_mark[0].str); }
#line 2738 "xkbparse.c"
break;
case 167:
#line 721 "xkbparse.y"
	{ yyval.expr= AppendKeysymList(yystack.l_mark[-2].expr,strdup("NoSymbol")); }
#line 2743 "xkbparse.c"
break;
case 168:
#line 723 "xkbparse.y"
	{ yyval.expr= CreateKeysymList(yystack.l_mark[0].str); }
#line 2748 "xkbparse.c"
break;
case 169:
#line 725 "xkbparse.y"
	{ yyval.expr= CreateKeysymList(strdup("NoSymbol")); }
#line 2753 "xkbparse.c"
break;
case 170:
#line 728 "xkbparse.y"
	{ yyval.str= strdup(scanBuf); }
#line 2758 "xkbparse.c"
break;
case 171:
#line 729 "xkbparse.y"
	{ yyval.str= strdup("section"); }
#line 2763 "xkbparse.c"
break;
case 172:
#line 731 "xkbparse.y"
	{
			    if (yystack.l_mark[0].ival<10)	{ yyval.str= malloc(2); yyval.str[0]= '0' + yystack.l_mark[0].ival; yyval.str[1]= '\0'; }
			    else	{ yyval.str= malloc(19); snprintf(yyval.str, 19, "0x%x", yystack.l_mark[0].ival); }
			}
#line 2771 "xkbparse.c"
break;
case 173:
#line 738 "xkbparse.y"
	{ yyval.expr= yystack.l_mark[-1].expr; }
#line 2776 "xkbparse.c"
break;
case 174:
#line 741 "xkbparse.y"
	{ yyval.ival= -yystack.l_mark[0].ival; }
#line 2781 "xkbparse.c"
break;
case 175:
#line 742 "xkbparse.y"
	{ yyval.ival= yystack.l_mark[0].ival; }
#line 2786 "xkbparse.c"
break;
case 176:
#line 745 "xkbparse.y"
	{ yyval.ival= scanInt; }
#line 2791 "xkbparse.c"
break;
case 177:
#line 746 "xkbparse.y"
	{ yyval.ival= scanInt*XkbGeomPtsPerMM; }
#line 2796 "xkbparse.c"
break;
case 178:
#line 749 "xkbparse.y"
	{ yyval.ival= scanInt; }
#line 2801 "xkbparse.c"
break;
case 179:
#line 752 "xkbparse.y"
	{ yyval.ival= scanInt; }
#line 2806 "xkbparse.c"
break;
case 180:
#line 755 "xkbparse.y"
	{ yyval.str= strdup(scanBuf); }
#line 2811 "xkbparse.c"
break;
case 181:
#line 758 "xkbparse.y"
	{ yyval.sval= XkbInternAtom(NULL,scanBuf,False); }
#line 2816 "xkbparse.c"
break;
case 182:
#line 759 "xkbparse.y"
	{ yyval.sval= XkbInternAtom(NULL,"default",False); }
#line 2821 "xkbparse.c"
break;
case 183:
#line 762 "xkbparse.y"
	{ yyval.sval= XkbInternAtom(NULL,scanBuf,False); }
#line 2826 "xkbparse.c"
break;
case 184:
#line 765 "xkbparse.y"
	{ yyval.str= yystack.l_mark[0].str; }
#line 2831 "xkbparse.c"
break;
case 185:
#line 766 "xkbparse.y"
	{ yyval.str= NULL; }
#line 2836 "xkbparse.c"
break;
case 186:
#line 769 "xkbparse.y"
	{ yyval.str= strdup(scanBuf); }
#line 2841 "xkbparse.c"
break;
#line 2843 "xkbparse.c"
    default:
        break;
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark -= yym;
#endif
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
        {
            fprintf(stderr, "%s[%d]: after reduction, ", YYDEBUGSTR, yydepth);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
            if (!yytrial)
#endif /* YYBTYACC */
                fprintf(stderr, "result is <%s>, ", YYSTYPE_TOSTRING(yystos[YYFINAL], yyval));
#endif
            fprintf(stderr, "shifting from state 0 to final state %d\n", YYFINAL);
        }
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        *++yystack.p_mark = yyloc;
#endif
        if (yychar < 0)
        {
#if YYBTYACC
            do {
            if (yylvp < yylve)
            {
                /* we're currently re-reading tokens */
                yylval = *yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylloc = *yylpp++;
#endif
                yychar = *yylexp++;
                break;
            }
            if (yyps->save)
            {
                /* in trial mode; save scanner results for future parse attempts */
                if (yylvp == yylvlim)
                {   /* Enlarge lexical value queue */
                    size_t p = (size_t) (yylvp - yylvals);
                    size_t s = (size_t) (yylvlim - yylvals);

                    s += YYLVQUEUEGROWTH;
                    if ((yylexemes = (YYINT *)realloc(yylexemes, s * sizeof(YYINT))) == NULL)
                        goto yyenomem;
                    if ((yylvals   = (YYSTYPE *)realloc(yylvals, s * sizeof(YYSTYPE))) == NULL)
                        goto yyenomem;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    if ((yylpsns   = (YYLTYPE *)realloc(yylpsns, s * sizeof(YYLTYPE))) == NULL)
                        goto yyenomem;
#endif
                    yylvp   = yylve = yylvals + p;
                    yylvlim = yylvals + s;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpp   = yylpe = yylpsns + p;
                    yylplim = yylpsns + s;
#endif
                    yylexp  = yylexemes + p;
                }
                *yylexp = (YYINT) YYLEX;
                *yylvp++ = yylval;
                yylve++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                *yylpp++ = yylloc;
                yylpe++;
#endif
                yychar = *yylexp++;
                break;
            }
            /* normal operation, no conflict encountered */
#endif /* YYBTYACC */
            yychar = YYLEX;
#if YYBTYACC
            } while (0);
#endif /* YYBTYACC */
            if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
            if (yydebug)
            {
                if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
                fprintf(stderr, "%s[%d]: state %d, reading token %d (%s)\n",
                                YYDEBUGSTR, yydepth, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == YYEOF) goto yyaccept;
        goto yyloop;
    }
    if (((yyn = yygindex[yym]) != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
    {
        fprintf(stderr, "%s[%d]: after reduction, ", YYDEBUGSTR, yydepth);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
            fprintf(stderr, "result is <%s>, ", YYSTYPE_TOSTRING(yystos[yystate], yyval));
#endif
        fprintf(stderr, "shifting from state %d to state %d\n", *yystack.s_mark, yystate);
    }
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    *++yystack.s_mark = (YYINT) yystate;
    *++yystack.l_mark = yyval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    *++yystack.p_mark = yyloc;
#endif
    goto yyloop;
#if YYBTYACC

    /* Reduction declares that this path is valid. Set yypath and do a full parse */
yyvalid:
    if (yypath) YYABORT;
    while (yyps->save)
    {
        YYParseState *save = yyps->save;
        yyps->save = save->save;
        save->save = yypath;
        yypath = save;
    }
#if YYDEBUG
    if (yydebug)
        fprintf(stderr, "%s[%d]: state %d, CONFLICT trial successful, backtracking to state %d, %d tokens\n",
                        YYDEBUGSTR, yydepth, yystate, yypath->state, (int)(yylvp - yylvals - yypath->lexeme));
#endif
    if (yyerrctx)
    {
        yyFreeState(yyerrctx);
        yyerrctx = NULL;
    }
    yylvp          = yylvals + yypath->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yylpp          = yylpsns + yypath->lexeme;
#endif
    yylexp         = yylexemes + yypath->lexeme;
    yychar         = YYEMPTY;
    yystack.s_mark = yystack.s_base + (yypath->yystack.s_mark - yypath->yystack.s_base);
    memcpy (yystack.s_base, yypath->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
    yystack.l_mark = yystack.l_base + (yypath->yystack.l_mark - yypath->yystack.l_base);
    memcpy (yystack.l_base, yypath->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark = yystack.p_base + (yypath->yystack.p_mark - yypath->yystack.p_base);
    memcpy (yystack.p_base, yypath->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
    yystate        = yypath->state;
    goto yyloop;
#endif /* YYBTYACC */

yyoverflow:
    YYERROR_CALL("yacc stack overflow");
#if YYBTYACC
    goto yyabort_nomem;
yyenomem:
    YYERROR_CALL("memory exhausted");
yyabort_nomem:
#endif /* YYBTYACC */
    yyresult = 2;
    goto yyreturn;

yyabort:
    yyresult = 1;
    goto yyreturn;

yyaccept:
#if YYBTYACC
    if (yyps->save) goto yyvalid;
#endif /* YYBTYACC */
    yyresult = 0;

yyreturn:
#if defined(YYDESTRUCT_CALL)
    if (yychar != YYEOF && yychar != YYEMPTY)
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        YYDESTRUCT_CALL("cleanup: discarding token", yychar, &yylval, &yylloc);
#else
        YYDESTRUCT_CALL("cleanup: discarding token", yychar, &yylval);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */

    {
        YYSTYPE *pv;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        YYLTYPE *pp;

        for (pv = yystack.l_base, pp = yystack.p_base; pv <= yystack.l_mark; ++pv, ++pp)
             YYDESTRUCT_CALL("cleanup: discarding state",
                             yystos[*(yystack.s_base + (pv - yystack.l_base))], pv, pp);
#else
        for (pv = yystack.l_base; pv <= yystack.l_mark; ++pv)
             YYDESTRUCT_CALL("cleanup: discarding state",
                             yystos[*(yystack.s_base + (pv - yystack.l_base))], pv);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
    }
#endif /* defined(YYDESTRUCT_CALL) */

#if YYBTYACC
    if (yyerrctx)
    {
        yyFreeState(yyerrctx);
        yyerrctx = NULL;
    }
    while (yyps)
    {
        YYParseState *save = yyps;
        yyps = save->save;
        save->save = NULL;
        yyFreeState(save);
    }
    while (yypath)
    {
        YYParseState *save = yypath;
        yypath = save->save;
        save->save = NULL;
        yyFreeState(save);
    }
#endif /* YYBTYACC */
    yyfreestack(&yystack);
    return (yyresult);
}
